#ifndef XML_H    /** Multi-include protection.   <FILENAME>_H */
#define XML_H


/*****************************************************************************/
/* Copyright (c) 2008 NXP B.V.                                               */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify      */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation, using version 2 of the License.             */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307       */
/* USA.                                                                      */
/*                                                                           */
/*****************************************************************************/
/**
    @file   xml.h
    @brief  XML functions.

@b  Application: tmmanifest

*//*

Rev Date        Author      Comments
--------------------------------------------------------------------------------
  1 20080520    batelaan    Initial
--------------------------------------------------------------------------------
    For consistency and standardisation retain the Section Separators.
*/


/*******************
* INCLUDE FILES    *
********************/

#include <tmNxTypes.h>
#include <stdio.h>
#include <stdbool.h>

/**************************************************************************
* EXPORTED MACROS                          PH_STBTEMPLATE_<_WORD>+        *
***************************************************************************/

/** Maximum string length of an xml attribute value.
    @see xmlAttr()
*/
#define MAX_XML_ATTR_VALUE_LEN 1023

/*********************************************************************
* EXPORTED TYPEDEFS                      [p]xml_<Word>+_t  *
**********************************************************************/

/**************************************************************************
* EXPORTED DATA                     g[k|p|kp|pk|kpk]xml_<Word>+ *
***************************************************************************/

extern FILE * gpxmlFilePtr;
extern bool gxmlTagNeedClosing;

/****************************************************************************
* EXPORTED FUNCTION PROTOTYPES                    xml[_<Word>+]   *
*****************************************************************************/

#ifdef __cplusplus
extern "C"
{
#endif

/******************************************************************************/

    extern void xmlSetOutput(FILE *fp);

    extern void xmlCheckState(void);

    extern void xmlStartTag(const char *tag);

    extern void xmlEndTag(const char *tag);

    extern void xmlIndent(int count);

    extern void xmlText(const char *text);

    extern void xmlAttr(const char *name, const char * format, ...);

#define xmlStringAttr(_name, _value) xmlAttr((_name), "%s", (_value))
#define xmlIntAttr(_name, _value) xmlAttr((_name), "%d", (_value))
#define xmlUIntAttr(_name, _value) xmlAttr((_name), "%u", (_value))

/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

/******************************************************************************/
#ifdef __cplusplus
}
#endif

#endif /* XML_H      Do not add any thing below this line */
