/*****************************************************************************/
/* Copyright (c) 2008 NXP B.V.                                               */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify      */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation, using version 2 of the License.             */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307       */
/* USA.                                                                      */
/*                                                                           */
/*****************************************************************************/
/**
    @file   zlibsupport.c
    @brief  Support for compressed modules

@b  Application: tmmanifest

Support for compressed modules.  Willy Tarreau <willy@meta-x.org>
did the support for modutils, Andrey Borzenkov <arvidjaar@mail.ru>
ported it to module-init-tools, and I said it was too ugly to live
and rewrote it 8).

(C) 2003 Rusty Russell, IBM Corporation.

Taken from module-init-tools package, version 3.2.2.
*//*

Rev Date        Author      Comments
--------------------------------------------------------------------------------
  1 20080520    batelaan    Initial from module-init-tools package, version 3.2.2.
--------------------------------------------------------------------------------
    For consistency and standardisation retain the Section Separators.
*/

#ifndef _ZLIB_SUPPORT_H
#define _ZLIB_SUPPORT_H

/* Grab file.  Decompresses if that is supported.  Returns NULL on error. */
extern void *grab_file(const char *filename, unsigned long *size);
extern void *grab_fd(int fd, unsigned long *size);

/* Free it up. */
extern void release_file(void *data, unsigned long size);

#endif /* _ZLIB_SUPPORT_H */
