#############################################################
#
# dhcpcd
#
#############################################################
DHCPCD_VER:=3.1.8
DHCPCD_SOURCE:=dhcpcd-$(DHCPCD_VER).tar.bz2
DHCPCD_SITE:=http://download.berlios.de/dhcpcd
DHCPCD_DIR:=$(BUILD_DIR)/dhcpcd-$(DHCPCD_VER)
DHCPCD_CAT:=$(BZCAT)
DHCPCD_BINARY:=src/dhcpcd
DHCPCD_TARGET_BINARY:=bin/dhcpcd

$(DL_DIR)/$(DHCPCD_SOURCE):
	$(WGET) -P $(DL_DIR) $(DHCPCD_SITE)/$(DHCPCD_SOURCE)

dhcpcd-source: $(DL_DIR)/$(DHCPCD_SOURCE)

$(DHCPCD_DIR)/.unpacked: $(DL_DIR)/$(DHCPCD_SOURCE)
	$(DHCPCD_CAT) $(DL_DIR)/$(DHCPCD_SOURCE) | tar -C $(BUILD_DIR) $(TAR_OPTIONS) -
	touch $(DHCPCD_DIR)/.unpacked

$(DHCPCD_DIR)/.configured: $(DHCPCD_DIR)/.unpacked
	touch $(DHCPCD_DIR)/.configured

$(DHCPCD_DIR)/$(DHCPCD_BINARY): $(DHCPCD_DIR)/.configured
	$(TARGET_CONFIGURE_OPTS) $(MAKE) CC=$(TARGET_CC) HAVE_FORK=yes HAVE_INIT=no DESTDIR=$(TARGET_DIR) -C $(DHCPCD_DIR) install

$(TARGET_DIR)/$(DHCPCD_TARGET_BINARY): $(DHCPCD_DIR)/$(DHCPCD_BINARY)
#	install -D $(DHCPCD_DIR)/$(DHCPCD_BINARY) $(TARGET_DIR)/$(DHCPCD_TARGET_BINARY)

dhcpcd: uclibc $(TARGET_DIR)/$(DHCPCD_TARGET_BINARY)

dhcpcd-clean:
	rm -f $(TARGET_DIR)/$(DHCPCD_TARGET_BINARY)
	-$(MAKE) -C $(DHCPCD_DIR) clean

dhcpcd-dirclean:
	rm -rf $(DHCPCD_DIR)
#############################################################
#
# Toplevel Makefile options
#
#############################################################
ifeq ($(strip $(BR2_PACKAGE_DHCPCD)),y)
TARGETS+=dhcpcd
endif
