#############################################################
#
# linuxtv-dvb-apps
#
#############################################################
LINUXTV_DVB_APPS_VER:=1.1.1
LINUXTV_DVB_APPS_SOURCE:=linuxtv-dvb-apps-$(LINUXTV_DVB_APPS_VER).tar.bz2
LINUXTV_DVB_APPS_SITE:=http://www.linuxtv.org/downloads/
LINUXTV_DVB_APPS_CAT:=bzcat
LINUXTV_DVB_APPS_DIR:=$(BUILD_DIR)/linuxtv-dvb-apps-$(LINUXTV_DVB_APPS_VER)
LINUXTV_DVB_APPS_BINARY:=scan
LINUXTV_DVB_APPS_TARGET_DIR:=$(TARGET_DIR)$(_TMTGTPREFIX)/bin

$(DL_DIR)/$(LINUXTV_DVB_APPS_SOURCE):
	 $(WGET) -P $(DL_DIR) $(LINUXTV_DVB_APPS_SITE)/$(LINUXTV_DVB_APPS_SOURCE)

linuxtv-dvb-apps-source: $(DL_DIR)/$(LINUXTV_DVB_APPS_SOURCE)

$(LINUXTV_DVB_APPS_DIR)/.unpacked: $(DL_DIR)/$(LINUXTV_DVB_APPS_SOURCE)
	$(LINUXTV_DVB_APPS_CAT) $(DL_DIR)/$(LINUXTV_DVB_APPS_SOURCE) | tar -C $(BUILD_DIR) $(TAR_OPTIONS) -
	touch $(LINUXTV_DVB_APPS_DIR)/.unpacked

$(LINUXTV_DVB_APPS_DIR)/.compiled: $(LINUXTV_DVB_APPS_DIR)/.unpacked
	$(MAKE) $(TARGET_CONFIGURE_OPTS)  -C $(LINUXTV_DVB_APPS_DIR)
	touch $(LINUXTV_DVB_APPS_DIR)/.compiled

LINUXTV_DVB_APPS_TARGETS_n :=
LINUXTV_DVB_APPS_TARGETS_y :=

LINUXTV_DVB_APPS_TARGETS_$(BR2_PACKAGE_LINUXTV_DVB_APPS_SCAN)		+= scan
LINUXTV_DVB_APPS_TARGETS_$(BR2_PACKAGE_LINUXTV_DVB_APPS_DVBDATE)	+= dvbdate
LINUXTV_DVB_APPS_TARGETS_$(BR2_PACKAGE_LINUXTV_DVB_APPS_DVBNET)		+= dvbnet
LINUXTV_DVB_APPS_TARGETS_$(BR2_PACKAGE_LINUXTV_DVB_APPS_DVBTRAFFIC)	+= dvbtraffic
LINUXTV_DVB_APPS_TARGETS_$(BR2_PACKAGE_LINUXTV_DVB_APPS_CZAP)		+= czap
LINUXTV_DVB_APPS_TARGETS_$(BR2_PACKAGE_LINUXTV_DVB_APPS_SZAP)		+= szap
LINUXTV_DVB_APPS_TARGETS_$(BR2_PACKAGE_LINUXTV_DVB_APPS_TZAP)		+= tzap
LINUXTV_DVB_APPS_TARGETS_$(BR2_PACKAGE_LINUXTV_DVB_APPS_FEMON)		+= femon

LINUXTV_DVB_APPS_BUILD_TARGETS := $(addprefix $(LINUXTV_DVB_APPS_TARGET_DIR)/, $(LINUXTV_DVB_APPS_TARGETS_y))

$(LINUXTV_DVB_APPS_TARGET_DIR)/scan:$(LINUXTV_DVB_APPS_DIR)/.compiled
	mkdir -p $(LINUXTV_DVB_APPS_TARGET_DIR)
	mkdir -p $(TARGET_DIR)$(_TMTGTPREFIX)/share
	cp $(LINUXTV_DVB_APPS_DIR)/util/scan/scan $(LINUXTV_DVB_APPS_TARGET_DIR)/scan
	-$(STRIPCMD) $(STRIP_STRIP_UNNEEDED) $(LINUXTV_DVB_APPS_TARGET_DIR)/scan
ifeq ($(BR2_PACKAGE_LINUXTV_DVB_APPS_SCAN_DVBC),y)
	cp -af $(LINUXTV_DVB_APPS_DIR)/util/scan/dvb-c $(TARGET_DIR)$(_TMTGTPREFIX)/share
endif
ifeq ($(BR2_PACKAGE_LINUXTV_DVB_APPS_SCAN_DVBS),y)
	cp -af $(LINUXTV_DVB_APPS_DIR)/util/scan/dvb-s $(TARGET_DIR)$(_TMTGTPREFIX)/share
endif
ifeq ($(BR2_PACKAGE_LINUXTV_DVB_APPS_SCAN_DVBT),y)
	cp -af $(LINUXTV_DVB_APPS_DIR)/util/scan/dvb-t $(TARGET_DIR)$(_TMTGTPREFIX)/share
endif

$(LINUXTV_DVB_APPS_TARGET_DIR)/dvbdate:$(LINUXTV_DVB_APPS_DIR)/.compiled
	mkdir -p $(LINUXTV_DVB_APPS_TARGET_DIR)
	cp $(LINUXTV_DVB_APPS_DIR)/util/dvbdate/dvbdate $(LINUXTV_DVB_APPS_TARGET_DIR)/dvbdate
	-$(STRIPCMD) $(STRIP_STRIP_UNNEEDED) $(LINUXTV_DVB_APPS_TARGET_DIR)/dvbdate

$(LINUXTV_DVB_APPS_TARGET_DIR)/dvbnet:$(LINUXTV_DVB_APPS_DIR)/.compiled
	mkdir -p $(LINUXTV_DVB_APPS_TARGET_DIR)
	cp $(LINUXTV_DVB_APPS_DIR)/util/dvbnet/dvbnet $(LINUXTV_DVB_APPS_TARGET_DIR)/dvbnet
	-$(STRIPCMD) $(STRIP_STRIP_UNNEEDED) $(LINUXTV_DVB_APPS_TARGET_DIR)/dvbnet

$(LINUXTV_DVB_APPS_TARGET_DIR)/dvbtraffic:$(LINUXTV_DVB_APPS_DIR)/.compiled
	mkdir -p $(LINUXTV_DVB_APPS_TARGET_DIR)
	cp $(LINUXTV_DVB_APPS_DIR)/util/dvbtraffic/dvbtraffic $(LINUXTV_DVB_APPS_TARGET_DIR)/dvbtraffic
	-$(STRIPCMD) $(STRIP_STRIP_UNNEEDED) $(LINUXTV_DVB_APPS_TARGET_DIR)/dvbtraffic

$(LINUXTV_DVB_APPS_TARGET_DIR)/czap:$(LINUXTV_DVB_APPS_DIR)/.compiled
	mkdir -p $(LINUXTV_DVB_APPS_TARGET_DIR)
	cp $(LINUXTV_DVB_APPS_DIR)/util/szap/czap $(LINUXTV_DVB_APPS_TARGET_DIR)/czap
	-$(STRIPCMD) $(STRIP_STRIP_UNNEEDED) $(LINUXTV_DVB_APPS_TARGET_DIR)/czap


$(LINUXTV_DVB_APPS_TARGET_DIR)/szap:$(LINUXTV_DVB_APPS_DIR)/.compiled
	mkdir -p $(LINUXTV_DVB_APPS_TARGET_DIR)
	cp $(LINUXTV_DVB_APPS_DIR)/util/szap/szap $(LINUXTV_DVB_APPS_TARGET_DIR)/szap
	-$(STRIPCMD) $(STRIP_STRIP_UNNEEDED) $(LINUXTV_DVB_APPS_TARGET_DIR)/szap

$(LINUXTV_DVB_APPS_TARGET_DIR)/tzap:$(LINUXTV_DVB_APPS_DIR)/.compiled
	mkdir -p $(LINUXTV_DVB_APPS_TARGET_DIR)
	cp $(LINUXTV_DVB_APPS_DIR)/util/szap/tzap $(LINUXTV_DVB_APPS_TARGET_DIR)/tzap
	-$(STRIPCMD) $(STRIP_STRIP_UNNEEDED) $(LINUXTV_DVB_APPS_TARGET_DIR)/tzap

$(LINUXTV_DVB_APPS_TARGET_DIR)/femon:$(LINUXTV_DVB_APPS_DIR)/.compiled
	mkdir -p $(LINUXTV_DVB_APPS_TARGET_DIR)
	cp $(LINUXTV_DVB_APPS_DIR)/util/szap/femon $(LINUXTV_DVB_APPS_TARGET_DIR)/femon
	-$(STRIPCMD) $(STRIP_STRIP_UNNEEDED) $(LINUXTV_DVB_APPS_TARGET_DIR)/femon

linuxtv-dvb-apps: uclibc $(LINUXTV_DVB_APPS_BUILD_TARGETS)

linuxtv-dvb-apps-clean:
	-$(MAKE) -C $(LINUXTV_DVB_APPS_DIR) clean

linuxtv-dvb-apps-dirclean:
	rm -rf $(LINUXTV_DVB_APPS_DIR)

#############################################################
#
# Toplevel Makefile options
#
#############################################################
ifeq ($(strip $(BR2_PACKAGE_LINUXTV_DVB_APPS)),y)
TARGETS+=linuxtv-dvb-apps
endif

