_DQUOTE:="
#"

#
# copy_toolchain_lib_root
#
# $1: source
# $2: destination
# $3: strip (y|n)       default is to strip
#
copy_toolchain_lib_root = \
	LIB="$(strip $1)"; \
	DST="$(strip $2)"; \
	STRIP="$(strip $3)"; \
 \
	LIB_DIR=`$(TARGET_CC) -print-file-name=$${LIB} | sed -e "s,/$${LIB}\$$,,"`; \
 \
	if test -z "$${LIB_DIR}"; then \
		echo "copy_toolchain_lib_root: lib=$${LIB} not found"; \
		exit -1; \
	fi; \
 \
	LIB="$(strip $1)"; \
	for FILE in `find $${LIB_DIR}/ -maxdepth 1 -type l -name "$${LIB}*"`; do \
		LIB=`basename $${FILE}`; \
		while test \! -z "$${LIB}"; do \
			echo "copy_toolchain_lib_root lib=$${LIB} dst=$${DST}"; \
			rm -fr $(TARGET_DIR)$${DST}/$${LIB}; \
			mkdir -p $(TARGET_DIR)$${DST}; \
			if test -h $${LIB_DIR}/$${LIB}; then \
				cp -d $${LIB_DIR}/$${LIB} $(TARGET_DIR)$${DST}/; \
				cp -d $${LIB_DIR}/$${LIB} $(STAGING_DIR)$${DST}/; \
			elif test -f $${LIB_DIR}/$${LIB}; then \
				install -D -m0755 $${LIB_DIR}/$${LIB} $(TARGET_DIR)$${DST}/$${LIB}; \
				install -D -m0755 $${LIB_DIR}/$${LIB} $(STAGING_DIR)$${DST}/$${LIB}; \
				case "$${STRIP}" in \
				(0 | n | no) \
;; \
				(*) \
					$(TARGET_CROSS)strip "$(TARGET_DIR)$${DST}/$${LIB}"; \
;; \
				esac; \
			else \
				exit -1; \
			fi; \
			LIB="`readlink $${LIB_DIR}/$${LIB}`"; \
		done; \
	done; \
 \
	echo -n

copy_toolchain_sysroot = \
	if [ -z "$${BR2_TOOLCHAIN_SYSROOT_PATH}" ]; then \
		echo "Auto-detecting sysroot..."; \
		SYSROOT_DIR=`$(TARGET_CC) -v 2>&1 | grep ^Configured | tr " " "\n" | grep -- --with-sysroot | cut -f2 -d=`; \
	else \
		echo "Using specified sysroot:"; \
		SYSROOT_DIR=$${BR2_TOOLCHAIN_SYSROOT_PATH}; \
	fi; \
	if [ -n "$${SYSROOT_DIR}" ]; then \
		echo "    Using SYSROOT value of $${SYSROOT_DIR}"; \
		cp -a $${SYSROOT_DIR}/* $(STAGING_DIR)/ ; \
		rm -rf $(STAGING_DIR)/usr/bin/ ; \
		find $(STAGING_DIR) -type d | xargs chmod 755; \
	fi

uclibc: dependencies $(TARGET_DIR)/lib/$(strip $(subst $(_DQUOTE),, $(BR2_TOOLCHAIN_EXTERNAL_LIB_C)))

COPY_TOOLCHAIN_TIMESTAMP_FILE := $(TOOL_BUILD_DIR)/.copy_toolchain_done
$(TARGET_DIR)/lib/$(strip $(subst $(_DQUOTE),, $(BR2_TOOLCHAIN_EXTERNAL_LIB_C))) : $(COPY_TOOLCHAIN_TIMESTAMP_FILE)

$(COPY_TOOLCHAIN_TIMESTAMP_FILE):
	mkdir -p $(TARGET_DIR)/lib
	@$(call copy_toolchain_lib_root, $(strip $(subst $(_DQUOTE),, $(BR2_TOOLCHAIN_EXTERNAL_LIB_C))), /lib, $(BR2_TOOLCHAIN_EXTERNAL_STRIP))
	for libs in $(strip $(subst $(_DQUOTE),, $(BR2_TOOLCHAIN_EXTERNAL_LIBS))); do \
		$(call copy_toolchain_lib_root, $$libs, /lib, $(BR2_TOOLCHAIN_EXTERNAL_STRIP)); \
	done
	$(call copy_toolchain_sysroot)
	mkdir -p $(dir $(COPY_TOOLCHAIN_TIMESTAMP_FILE))
	touch $(COPY_TOOLCHAIN_TIMESTAMP_FILE)

ifeq ($(BR2_TOOLCHAIN_EXTERNAL),y)
  cross_compiler: $(COPY_TOOLCHAIN_TIMESTAMP_FILE)
endif
