#ifndef PHKERNELIFCE_H    /* Multi-include protection.   <FILENAME>_H */
#define PHKERNELIFCE_H


/*****************************************************************************/
/* Copyright (c) 2008 NXP B.V.                                               */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify      */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation, using version 2 of the License.             */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307       */
/* USA.                                                                      */
/*                                                                           */
/*****************************************************************************/
/**
    @file   phKernelIfce.h
    @brief  Generic usermode to kernelspace API framework.

@b  Component:  phKernelIfce

*//*

Rev Date        Author      Comments
--------------------------------------------------------------------------------
  1 20061012    batelaan    Initial
  2 20061020    batelaan    Include phKernelIfce_UserMode.h or phKernelIfce_Kernel.h depending.
  3 20071002    batelaan    Portability enhancements
  4 20080206    batelaan    Update file copyright/license text
  5 20080617    batelaan    Update file copyright/license text
--------------------------------------------------------------------------------
    For consistency and standardisation retain the Section Separators.
*/

/*******************
* INCLUDE FILES    *
********************/

#include <tmNxTypes.h>
#include <tmNxCompId.h>

#if TMFL_MODE_KERNEL
  #include <phKernelIfce_Kernel.h>
#else
  #include <phKernelIfce_UserMode.h>
#endif

#ifdef __cplusplus
extern "C"
{
#endif

/**************************************************************************
* EXPORTED MACROS                          PH_KERNELIFCE_<_WORD>+             *
***************************************************************************/

/*********************************************************************
* EXPORTED TYPEDEFS                      [p]phKernelIfce_<Word>+_t       *
**********************************************************************/

/**************************************************************************
* EXPORTED DATA                     g[k|p|kp|pk|kpk]phKernelIfce_<Word>+      *
***************************************************************************/

/****************************************************************************
* EXPORTED FUNCTION PROTOTYPES                    phKernelIfce[_<Word>+]        *
*****************************************************************************/

#ifdef __cplusplus
}
#endif

#endif /* PHKERNELIFCE_H      Do not add any thing below this line */
