#ifndef PHKERNELIFCE_USERMODE_H    /* Multi-include protection.   <FILENAME>_H */
#define PHKERNELIFCE_USERMODE_H


/*****************************************************************************/
/* Copyright (c) 2009 NXP B.V.  All rights are reserved.                     */
/*                                                                           */
/* Redistribution and use in source and binary forms, with or without        */
/* modification, are permitted provided that the following conditions        */
/* are met:                                                                  */
/*                                                                           */
/* Redistributions of source code must retain the above copyright            */
/* notice, this list of conditions and the following disclaimer.             */
/*                                                                           */
/* Redistributions in binary form must reproduce the above copyright         */
/* notice, this list of conditions and the following disclaimer in the       */
/* documentation and/or other materials provided with the distribution.      */
/*                                                                           */
/* Neither the name of NXP nor the names of its                              */
/* contributors may be used to endorse or promote products derived from      */
/* this software without specific prior written permission.                  */
/*                                                                           */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS       */
/* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT         */
/* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR     */
/* A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT      */
/* OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,     */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT          */
/* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,     */
/* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY     */
/* THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT       */
/* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE         */
/* USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH          */
/* DAMAGE.                                                                   */
/*                                                                           */
/*****************************************************************************/
/**
    @file   phKernelIfce_UserMode.h
    @brief  Usermode include file for generic usermode to kernelspace API framework.

@b  Component:  phKernelIfce

    Do not include directly. Please include phKernelIfce.h instead.

*//*

Rev Date        Author      Comments
--------------------------------------------------------------------------------
  1 20061012    batelaan    Initial
  2 20061020    batelaan    Crosscheck fixes
  3 20071210    hutchinson  Merged in EB's changes from their 071128 release.
  4 20080206    batelaan    Update file copyright/license text
  5 20090120    batelaan    Update file copyright/license text
--------------------------------------------------------------------------------
    For consistency and standardisation retain the Section Separators.
*/

/*******************
* INCLUDE FILES    *
********************/

#ifndef PHKERNELIFCE_H
  #error Please include phKernelIfce.h instead.
#endif

#if !TMFL_OS_IS_CE
#include <sys/types.h>
#endif

#include <phKernelIfce_Common.h>

#ifdef __cplusplus
extern "C"
{
#endif

/**************************************************************************
* EXPORTED MACROS                          PH_KERNELIFCE_<_WORD>+             *
***************************************************************************/

/*********************************************************************
* EXPORTED TYPEDEFS                      [p]phKernelIfce_<Word>+_t       *
**********************************************************************/

/**************************************************************************
* EXPORTED DATA                     g[k|p|kp|pk|kpk]phKernelIfce_<Word>+      *
***************************************************************************/

/****************************************************************************
* EXPORTED FUNCTION PROTOTYPES                    phKernelIfce[_<Word>+]        *
*****************************************************************************/

/** Call a function in kernelspace from userspace.
    @param pCallData @b IN Structure used to pass information about
    a call from userspace to kernelspace and viceversa.
 */
void phKernelIfce_Call(
    pphKernelIfce_CallData_t pCallData
);
/******************************************************************************/
    
#ifdef __cplusplus
}
#endif

#endif /* PHKERNELIFCE_USERMODE_H      Do not add any thing below this line */
