/*  Copyright (C) 2006 NXP B.V.
    All Rights Reserved.
*//**
    @file   phKernelIfce_UserTest.c
    @brief  Test user space library for phKernelIfce component.

@b  Component:  phKernelIfce.

*//*

Rev Date       Author      Comments
--------------------------------------------------------------------------------
  1 20061012   batelaan    Initial 
  2 20061020   batelaan    Crosscheck fixes
--------------------------------------------------------------------------------
    For consistency and standardisation retain the Section Separators.
*/

#include <phKernelIfce.h>
#include <phStbDbg.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

#include <phExample1.h>

/***********************************************
* LOCAL MACROS                                 *
* recommendation only: <MODULE><_WORD>+        *
************************************************/

#define CHECK(expr, expected) { \
        tmErrorCode_t err; \
        printf("\n  %s\n", #expr);    \
        err = (expr); \
        if (err != (expected)) { \
            printf("**ERROR (0x%x - expected 0x%x): %s\n", err, (unsigned int)(expected), #expr); \
            return(1); \
        } \
    }

/******************************************************************
* FUNCTION PROTOTYPES                    [p]ph<Module>_<Word>+    *
*******************************************************************/

/******************************************************************
* LOCAL TYPEDEFS                                                  *
* recommendation only:                   [p]ph<Module>_<Word>+_t  *
*******************************************************************/

/*******************************************************************
* EXPORTED DATA                 g[k|p|kp|pk|kpk]ph<Module>_<Word>+ *
********************************************************************/

/*******************************************************************
* LOCAL DATA                                                       *
********************************************************************/

//PH_KERNELIFCE_DATA(NameSpace0_Func0);

/*******************************************************************************
* FUNCTION IMPLEMENTATION  <Module>[_<Word>+] for static functions             *
*                          tm[<layer>]<Module>[_<Word>+] for exported functions*
********************************************************************************/

int main(int argc, char **argv)
{
    int c;
    int ret;
    char s[200] = "Anyone there??? ";
    char *expectedString = "Anyone there???  Greetings from the kernel!";
    extern tmErrorCode_t phKernelIfce_Init(void);

    CHECK(phKernelIfce_Init(), TM_OK);
    DBG_UNIT_EXTERN(gphKernelIfce_DbgUnit);
    DBG_ENABLE_FLAGS(gphKernelIfce_DbgUnit, DBG_ALL_FLAGS);
    printf("phKernelIfce_UserTest: start\n");

    ret = phExample1_Function(10, 31, s, &c);

    printf("phExample1_Function(10, 31, \"Anyone there??? \", &c) => %d (s=\"%s\" c=%d)\n",
           ret, s, c);

    /* Check results: */
    if (c != 42)
    {
        fprintf(stderr, "\n**ERROR: %d not the right answer, expecting %d!\n", c, 42);
    }
    if (strcmp(expectedString, s) != 0)
    {
        fprintf(stderr, "\n**ERROR: \"%s\" not the right response,\n  expecting \"%s\"\n",
                s, expectedString);
    }

    printf("phKernelIfce_UserTest: end\n");
    return 0;
}

/******************************************************************************/
