#ifndef PHSTBBOOTDSP_H    /* Multi-include protection.   <FILENAME>_H */
#define PHSTBBOOTDSP_H


/*****************************************************************************/
/* Copyright (c) 2008 NXP B.V.                                               */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify      */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation, using version 2 of the License.             */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307       */
/* USA.                                                                      */
/*                                                                           */
/*****************************************************************************/
/**
    All Rights Reserved.
*//**
    @file   phStbBootDsp.h
    @brief  External header file for this component.

@b  Component:  phStbBootDsp

*//*

Rev Date        Author      Comments
--------------------------------------------------------------------------------
  1 20061201    batelaan    Initial
  2 20070103    batelaan    Added PH_STBBOOTDSP_DFLT_LOADFILE.
  3 20071210    hutchinson  Merged in EB's 071128 trunk.
 3.1.1 20080422 batelaan    Update file header
  4 20080327    laird       Change default filename for linux.
  5 20080410    batelaan    Use full pathname.
  6 20080423    batelaan    Merge 3.1.1
--------------------------------------------------------------------------------
    For consistency and standardisation retain the Section Separators.
*/

/*******************
* INCLUDE FILES    *
********************/

#include <tmNxTypes.h>

/**************************************************************************
* EXPORTED MACROS                          PH_STBTEMPLATE_<_WORD>+        *
***************************************************************************/

/** Path of uImage for the DSP, used to boot the DSP. */
#if TMFL_OS_IS_LINUX
#define PH_STBBOOTDSP_DFLT_LOADFILE "/lib/firmware/dsp.fw"
#endif

#if TMFL_OS_IS_CE
#define PH_STBBOOTDSP_DFLT_LOADFILE "/windows/uImage"
#endif

#ifndef PH_STBBOOTDSP_DFLT_LOADFILE
#error Unsupported OS
#endif

/*********************************************************************
* EXPORTED TYPEDEFS                      [p]phStbTemplate_<Word>+_t  *
**********************************************************************/

/**************************************************************************
* EXPORTED DATA                     g[k|p|kp|pk|kpk]phStbTemplate_<Word>+ *
***************************************************************************/

/****************************************************************************
* EXPORTED FUNCTION PROTOTYPES                    phStbTemplate[_<Word>+]   *
*****************************************************************************/

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef __cplusplus
}
#endif

#endif /* PHSTBBOOTDSP_H      Do not add any thing below this line */
