#ifndef PHSTBBOOTDSP_LINUX_INTERNAL_H    /* Multi-include protection.   <FILENAME>_H */
#define PHSTBBOOTDSP_LINUX_INTERNAL_H

/*****************************************************************************/
/* Copyright (c) 2008 NXP B.V.                                               */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify      */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation, using version 2 of the License.             */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307       */
/* USA.                                                                      */
/*                                                                           */
/*****************************************************************************/
/**
    @file   phStbBootDsp_Linux_Internal.h
    @brief  Linux internal header file for this component.

@b  Component:  phStbBootDsp

*//*

Rev Date        Author      Comments
--------------------------------------------------------------------------------
  1 20070710   batelaan    Initial
  2 20070919   batelaan    Portability fix.
  3 20080422   batelaan    Update file header
--------------------------------------------------------------------------------
    For consistency and standardisation retain the Section Separators.
*/

/*******************
* INCLUDE FILES    *
********************/

#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/errno.h>
#include <linux/fs.h>
#include <linux/file.h>
#include <linux/unistd.h>
#include <linux/syscalls.h>
#include <asm/uaccess.h>
#include <asm/delay.h>

/**************************************************************************
* EXPORTED MACROS                          PH_STBTEMPLATE_<_WORD>+        *
***************************************************************************/

#if PH_STBBOOTDSP_VERBOSE
#define DBGPRINT(_expr) do { if (gphStbBootDsp_Verbose) { printk _expr; } } while (0)
#endif

#define ERRPREFIX KERN_ERR "**ERROR: "
#define ERRPRINT(_expr) do { printk _expr; } while (0)

/*********************************************************************
* EXPORTED TYPEDEFS                      [p]phStbTemplate_<Word>+_t  *
**********************************************************************/

/**************************************************************************
* EXPORTED DATA                     g[k|p|kp|pk|kpk]phStbTemplate_<Word>+ *
***************************************************************************/

/****************************************************************************
* EXPORTED FUNCTION PROTOTYPES phStbTemplate[_<Word>+] *
*****************************************************************************/

#ifdef __cplusplus
extern "C"
{
#endif

/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

/******************************************************************************/
#ifdef __cplusplus
}
#endif

#endif /* PHSTBBOOTDSP_LINUX_INTERNAL_H      Do not add any thing below this line */
