#ifndef PHSTBDFB_H    /* Multi-include protection.   <FILENAME>_H */
#define PHSTBDFB_H


/*****************************************************************************/
/* Copyright (c) 2009 NXP B.V.                                               */
/*                                                                           */
/* This library is free software; you can redistribute it and/or             */
/* modify it under the terms of the GNU Lesser General Public                */
/* License as published by the Free Software Foundation, using               */
/* version 2.1 of the License.                                               */
/*                                                                           */
/* This library is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU          */
/* Lesser General Public License for more details.                           */
/*                                                                           */
/* You should have received a copy of the GNU Lesser General Public          */
/* License along with this library; if not, write to the Free Software       */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA   */
/*                                                                           */
/*****************************************************************************/
/**
    @file   phStbDFB.h
    @brief  Module header file for DirectFB graphics driver.

@b  Component:  phStbDFB.

*//*

Rev Date        Author      Comments
--------------------------------------------------------------------------------
  1 20050824    charrett    Original
  2
  3 20050920    laird       Added more functions for handling image/video.
  4 20051214    laird       Added utility function to get the current type of a layer.
-------------------------STB225-------------------------------------------------
  5 20070115    laird       Moving to STB225.
  6 20080104    laird       Cope with DirectFB version upgrade
  7 20080902    laird       Clean up header file.
  8 20090120    batelaan    Update file copyright/license text
--------------------------------------------------------------------------------
    For consistency and standardisation retain the Section Separators.
*/

/*******************
* INCLUDE FILES    *
********************/
#include <directfb.h>

/* The following allows phStbDFB_GetLayerId to work.*/
#ifdef DIRECTFB_1_0
#include <core/surfaces.h>
#endif

/**************************************************************************
* EXPORTED MACROS                               PH_STBDFB_<_WORD>+        *
***************************************************************************/

/**************************************************************************
* EXPORTED DATA                          g[k|p|kp|pk|kpk]phStbDfb_<Word>+ *
***************************************************************************/

/****************************************************************************
* EXPORTED FUNCTION PROTOTYPES                         phStbDfb[_<Word>+]   *
*****************************************************************************/
#ifdef DIRECTFB_1_0
/**
 * Detemine whether a surface is a layer surface and if it is which Video Renderer
 * layer it corresponds to.
 *
 * @param surface The core surface to test.
 * @param layerId If the surface is a layer surface this will be filled in
 *                with the renderer layer id.
 *
 * @retval DFB_OK when the surface is a layer surface or DFB_ITEMNOTFOUND if not.
 */
DFBResult phStbDFB_GetLayerId(CoreSurface *surface,
                              int         *layerId);
#endif

#endif /* PHSTBDFB_H      Do not add any thing below this line */

