#ifndef PHSTBFB_H    /** Multi-include protection.   <FILENAME>_H */
#define PHSTBFB_H


/*****************************************************************************/
/* Copyright (c) 2008 NXP B.V.                                               */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify      */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation, using version 2 of the License.             */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307       */
/* USA.                                                                      */
/*                                                                           */
/*****************************************************************************/
/**
    @file   phStbFB.h
    @brief  Linux implementation of the phStbFB driver.

    @b  Module:  phStbFB driver.

*//*

Rev Date        Author      Comments
--------------------------------------------------------------------------------
  1 20070214    neill       Original
  2 20070216    neill       Changes after crosscheck
  3 20080211    batelaan    Update file copyright/license text
--------------------------------------------------------------------------------
    For consistency and standardisation retain the Section Separators.
*/

#include <linux/ioctl.h>
#include <linux/types.h>

#if defined(__cplusplus)
extern "C" {
#endif

//  ****************************************************************************
//  *                                                                          *
//  *                           M O D U L E    S E C T I O N                   *
//  *                                                                          *
//  ****************************************************************************

//------------------------------------------------------------------------------
//                              I O C T L ' s  data structures
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//                              I O C T L ' s  definition
//------------------------------------------------------------------------------

/** The base of phStbFB ioctls */
#define PHSTBFB_IOCTL_BASE 0xFB00

/** Get the scaled destination rectangle */
#define PHSTBFB_IOCTL_GET_DEST_RECT _IOR(PHSTBFB_IOCTL_BASE, 0, unsigned int*)

/** Set the scaled destination rectangle */
#define PHSTBFB_IOCTL_SET_DEST_RECT _IOW(PHSTBFB_IOCTL_BASE, 0, unsigned int*)

//  ****************************************************************************
//  *                                                                          *
//  *                       P U B L I C    O B J E C T S                       *
//  *                                                                          *
//  ****************************************************************************

#if defined(__cplusplus)
}
#endif
#endif /* PHSTBFB_H */

