#if !defined(__PHSTBJPG_H)
#define __PHSTBJPG_H


/*****************************************************************************/
/* Copyright (c) 2008 NXP B.V.                                               */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify      */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation, using version 2 of the License.             */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307       */
/* USA.                                                                      */
/*                                                                           */
/*****************************************************************************/
/**
    @file   phStbJpg.h
    @brief  phStbJpg

@b  Application:  phStbJpg component

*//*

Rev Date        Author      Comments
--------------------------------------------------------------------------------
  1 20060329    neill       Original
  2 20070320    neill       Changes after QAC checking
  3 20071023    neill       More QAC checking
  4 20080208    batelaan    Update file copyright/license text

--------------------------------------------------------------------------------
    For consistency and standardisation retain the Section Separators.
*/

/*******************
* INCLUDE FILES    *
********************/

#include "phStbImage.h"

/*******************
* EXPORTED MACROS  *
********************/

/*********************
* EXPORTED TYPEDEFS  *
**********************/

#ifdef __cplusplus
extern "C"
{
#endif

/*******************
* EXPORTED DATA    *
********************/

/********************************
* EXPORTED FUNCTIONS PROTOTYPES *
*********************************/

/**
*   @brief Gets dimensions of a bitmap supplied in JPEG format.
*
*   @param  filename      I     File to be checked
*   @param  pWidth        O     Width of Image
*   @param  pHeight       O     Height of Image
* 
*   @retval PH_STB_OK if successful - else error
*/  
extern phStbImageErrorCode_t phStbJpg_GetDimensions( const char* filename, int32_t * pWidth, int32_t * pHeight );

/**
*   @brief Decodes a bitmap supplied in JPEG format..
*
*   @param  filename      I     File to be checked
*   @param  pSetup        I     Pointer to set up information - holding decode 
*                               information
* 
*   @retval PH_STB_OK if successful - else error
*/  
extern phStbImageErrorCode_t phStbJpg_Decode( const char* filename, phStbImage_SetupParams_t const * pSetup);

#ifdef __cplusplus
}
#endif

#endif /* __PHSTBJPG_H      Do not add any thing below this line */
