#ifndef PHSTBNETDEV_MAILBOX_H    /* Multi-include protection.   <FILENAME>_MAILBOX_H */
#define PHSTBNETDEV_MAILBOX_H


/*****************************************************************************/
/* Copyright (c) 2008 NXP B.V.                                               */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify      */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation, using version 2 of the License.             */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307       */
/* USA.                                                                      */
/*                                                                           */
/*****************************************************************************/
/**
    @file   phStbNetDev_Mailbox.h
    @brief  PNX8335 Mailbox access.

@b  Component:  phStbNetDev

*//*

Rev Date        Author      Comments
--------------------------------------------------------------------------------
  1 20061201   batelaan    Initial
  2 20070919   batelaan    Rm phStbNetDev_GetPoolPhysical
  3 20080422   batelaan    Update file header
--------------------------------------------------------------------------------
    For consistency and standardisation retain the Section Separators.
*/

/*******************
* INCLUDE FILES    *
********************/

#include <tmNxTypes.h>

/**************************************************************************
* EXPORTED MACROS                          PH_STBTEMPLATE_<_WORD>+        *
***************************************************************************/

/** MAILBOX0 interface meant for Audio CPU to interrupt Main CPU. */
#define PH_STBNETDEV_MAILBOX0 0x17e2c000UL
/** MAILBOX1 interface meant for Main CPU to interrupt Audio CPU. */
#define PH_STBNETDEV_MAILBOX1 0x17e2d000UL

#define PH_STBNETDEV_MAILBOX_MODULE_ID          0xffcUL
#define PH_STBNETDEV_MAILBOX_POWER_RESET        0xff4UL
#define PH_STBNETDEV_MAILBOX_INT_CLEAR          0xfe8UL
#define PH_STBNETDEV_MAILBOX_INT_ENABLE         0xfe4UL
#define PH_STBNETDEV_MAILBOX_INT_STATUS         0xfe0UL
//#define PH_STBNETDEV_MAILBOX_SRAM_ADDRESS       0x2fcUL or 0x100UL!!!
//#define PH_STBNETDEV_MAILBOX_SRAM_00_7F         0x100UL or 0x2fcUL!!!
#define PH_STBNETDEV_MAILBOX_EVENT_SET          0x080UL

/*********************************************************************
* EXPORTED TYPEDEFS                      [p]phStbTemplate_<Word>+_t  *
**********************************************************************/

/**************************************************************************
* EXPORTED DATA                     g[k|p|kp|pk|kpk]phStbTemplate_<Word>+ *
***************************************************************************/

/****************************************************************************
* EXPORTED FUNCTION PROTOTYPES                    phStbTemplate[_<Word>+]   *
*****************************************************************************/

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef __cplusplus
}
#endif

#endif /* PHSTBNETDEV_MAILBOX_H      Do not add any thing below this line */
