/*****************************************************************************/
/* Copyright (c) 2008 NXP B.V.                                               */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify      */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation, using version 2 of the License.             */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307       */
/* USA.                                                                      */
/*                                                                           */
/*****************************************************************************/
/**
    @file   phStbNetDev_LinuxUserMode.c
    @brief  Linux user mode code for phStbNetDev component.

@b  Component:  phStbNetDev.

*//*

Rev Date        Author      Comments
--------------------------------------------------------------------------------
  1 20080603    batelaan    Initial
  2 20080915    batelaan    Fix compilation warnings
--------------------------------------------------------------------------------
    For consistency and standardisation retain the Section Separators.
*/

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include "tmNxCompId.h"
#include "phStbNetDev.h"

/***********************************************
* LOCAL MACROS                                 *
* recommendation only: <MODULE><_WORD>+        *
************************************************/

/******************************************************************
* FUNCTION PROTOTYPES                    [p]ph<Module>_<Word>+    *
*******************************************************************/

/******************************************************************
* LOCAL TYPEDEFS                                                  *
* recommendation only:                   [p]ph<Module>_<Word>+_t  *
*******************************************************************/

/*******************************************************************
* EXPORTED DATA                 g[k|p|kp|pk|kpk]ph<Module>_<Word>+ *
********************************************************************/

/*******************************************************************
* LOCAL DATA                                                       *
********************************************************************/

/*******************************************************************************
* FUNCTION IMPLEMENTATION  <Module>[_<Word>+] for static functions             *
*                          tm[<layer>]<Module>[_<Word>+] for exported functions*
********************************************************************************/

tmErrorCode_t phStbNetDev_GetSubNet(char *address)
{
    tmErrorCode_t err = ~TM_OK;
    int fd;
    fd = open("/sys/module/phStbNetDev/parameters/subnet", O_RDONLY);
    if (fd >= 0)
    {
        ssize_t len;
        len = read(fd, address, PH_STBNETDEV_SUBNET_LEN);
        close(fd);
        if (len >= 0)
        {
            address[len] = '\0';
            err = TM_OK;
        }
    }
    return err;
}

/******************************************************************************/
