/*
 * (C) Copyright 2008 Andre McCurdy, NXP Semiconductors
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <asm/asm.h>
#include <asm/regdef.h>


/******************************************************************************/
/******************************************************************************/

	.text

	.globl	nand_ecc_generate
	.ent    nand_ecc_generate
	.type   nand_ecc_generate, @function

	.align	5			# plut data should be cacheline (ie 16 byte) aligned

nand_ecc_generate: 			# a0 : data

	.set	noreorder
	.set	noat

	move	t9, ra
	li	t0, 0x100		# t0 = i
	bal	1f
	li	t1, 0x200		# t1 = i_end

	.byte	0x00, 0x2b, 0x2d, 0x06, 0x33, 0x18, 0x1e, 0x35, 0x35, 0x1e, 0x18, 0x33, 0x06, 0x2d, 0x2b, 0x00
	.byte	0x4b, 0x60, 0x66, 0x4d, 0x78, 0x53, 0x55, 0x7e, 0x7e, 0x55, 0x53, 0x78, 0x4d, 0x66, 0x60, 0x4b
	.byte	0x4d, 0x66, 0x60, 0x4b, 0x7e, 0x55, 0x53, 0x78, 0x78, 0x53, 0x55, 0x7e, 0x4b, 0x60, 0x66, 0x4d
	.byte	0x06, 0x2d, 0x2b, 0x00, 0x35, 0x1e, 0x18, 0x33, 0x33, 0x18, 0x1e, 0x35, 0x00, 0x2b, 0x2d, 0x06
	.byte	0x53, 0x78, 0x7e, 0x55, 0x60, 0x4b, 0x4d, 0x66, 0x66, 0x4d, 0x4b, 0x60, 0x55, 0x7e, 0x78, 0x53
	.byte	0x18, 0x33, 0x35, 0x1e, 0x2b, 0x00, 0x06, 0x2d, 0x2d, 0x06, 0x00, 0x2b, 0x1e, 0x35, 0x33, 0x18
	.byte	0x1e, 0x35, 0x33, 0x18, 0x2d, 0x06, 0x00, 0x2b, 0x2b, 0x00, 0x06, 0x2d, 0x18, 0x33, 0x35, 0x1e
	.byte	0x55, 0x7e, 0x78, 0x53, 0x66, 0x4d, 0x4b, 0x60, 0x60, 0x4b, 0x4d, 0x66, 0x53, 0x78, 0x7e, 0x55
	.byte	0x55, 0x7e, 0x78, 0x53, 0x66, 0x4d, 0x4b, 0x60, 0x60, 0x4b, 0x4d, 0x66, 0x53, 0x78, 0x7e, 0x55
	.byte	0x1e, 0x35, 0x33, 0x18, 0x2d, 0x06, 0x00, 0x2b, 0x2b, 0x00, 0x06, 0x2d, 0x18, 0x33, 0x35, 0x1e
	.byte	0x18, 0x33, 0x35, 0x1e, 0x2b, 0x00, 0x06, 0x2d, 0x2d, 0x06, 0x00, 0x2b, 0x1e, 0x35, 0x33, 0x18
	.byte	0x53, 0x78, 0x7e, 0x55, 0x60, 0x4b, 0x4d, 0x66, 0x66, 0x4d, 0x4b, 0x60, 0x55, 0x7e, 0x78, 0x53
	.byte	0x06, 0x2d, 0x2b, 0x00, 0x35, 0x1e, 0x18, 0x33, 0x33, 0x18, 0x1e, 0x35, 0x00, 0x2b, 0x2d, 0x06
	.byte	0x4d, 0x66, 0x60, 0x4b, 0x7e, 0x55, 0x53, 0x78, 0x78, 0x53, 0x55, 0x7e, 0x4b, 0x60, 0x66, 0x4d
	.byte	0x4b, 0x60, 0x66, 0x4d, 0x78, 0x53, 0x55, 0x7e, 0x7e, 0x55, 0x53, 0x78, 0x4d, 0x66, 0x60, 0x4b
	.byte	0x00, 0x2b, 0x2d, 0x06, 0x33, 0x18, 0x1e, 0x35, 0x35, 0x1e, 0x18, 0x33, 0x06, 0x2d, 0x2b, 0x00

1:	move	t2, zero		# t2 = cp
	move	t3, zero		# t3 = lpo
2:	lbu	t4, 0(a0)		# t4 = data[0]
	xor	t5, t3, t0		# t5 = (lpo ^ i)
	addu	t4, t4, ra		# t4 = &plut[d]
	lbu	t6, 0(t4)		# t6 = plut[d]
	addiu	t0, t0, 1		# i++
	andi	t7, t6, 0x01		# t7 = (plut[d] & 0x01)
	movn	t3, t5, t7		# if (plut[d] & 0x01) then lpo = t5
	xor	t2, t2, t6		# cp ^= plut[d]
	lbu	t4, 1(a0)		# t4 = data[1]
	xor	t5, t3, t0		# t5 = (lpo ^ i)
	addu	t4, t4, ra		# t4 = &plut[d]
	lbu	t6, 0(t4)		# t6 = plut[d]
	addiu	t0, t0, 1		# i++
	andi	t7, t6, 0x01		# t7 = (plut[d] & 0x01)
	movn	t3, t5, t7		# if (plut[d] & 0x01) then lpo = t5
	xor	t2, t2, t6		# cp ^= plut[d]
	lbu	t4, 2(a0)		# t4 = data[2]
	xor	t5, t3, t0		# t5 = (lpo ^ i)
	addu	t4, t4, ra		# t4 = &plut[d]
	lbu	t6, 0(t4)		# t6 = plut[d]
	addiu	t0, t0, 1		# i++
	andi	t7, t6, 0x01		# t7 = (plut[d] & 0x01)
	movn	t3, t5, t7		# if (plut[d] & 0x01) then lpo = t5
	xor	t2, t2, t6		# cp ^= plut[d]
	lbu	t4, 3(a0)		# t4 = data[3]
	xor	t5, t3, t0		# t5 = (lpo ^ i)
	addiu	a0, a0, 4		# data += 4
	addu	t4, t4, ra		# t4 = &plut[d]
	lbu	t6, 0(t4)		# t6 = plut[d]
	addiu	t0, t0, 1		# i++
	andi	t7, t6, 0x01		# t7 = (plut[d] & 0x01)
	movn	t3, t5, t7		# if (plut[d] & 0x01) then lpo = t5
	bne	t0, t1, 2b
	xor	t2, t2, t6		# cp ^= plut[d]
	srl	t2, t2, 1
	sll	t2, t2, 2
	srl	t4, t3, 8
	nor	t5, zero, t3
	move	t6, t3
	movn	t6, t5, t4		# t6 = lpe = (lpo >> 8) ? ~lpo : lpo
	andi	t4, t3, (1 << 0)
	andi	t5, t6, (1 << 0)
	sll	t4, t4, 9
	sll	t5, t5, 8
	or	t2, t2, t4		# t2 |= ((lpo & (1 << 0)) << 9)
	or	t2, t2, t5		# t2 |= ((lpe & (1 << 0)) << 8)
	andi	t4, t3, (1 << 1)
	andi	t5, t6, (1 << 1)
	sll	t4, t4, 10
	sll	t5, t5, 9
	or	t2, t2, t4		# t2 |= ((lpo & (1 << 1)) << 10)
	or	t2, t2, t5		# t2 |= ((lpe & (1 << 1)) << 9)
	andi	t4, t3, (1 << 2)
	andi	t5, t6, (1 << 2)
	sll	t4, t4, 11
	sll	t5, t5, 10
	or	t2, t2, t4		# t2 |= ((lpo & (1 << 2)) << 11)
	or	t2, t2, t5		# t2 |= ((lpe & (1 << 2)) << 10)
	andi	t4, t3, (1 << 3)
	andi	t5, t6, (1 << 3)
	sll	t4, t4, 12
	sll	t5, t5, 11
	or	t2, t2, t4		# t2 |= ((lpo & (1 << 3)) << 12)
	or	t2, t2, t5		# t2 |= ((lpe & (1 << 3)) << 11)
	andi	t4, t3, (1 << 4)
	andi	t5, t6, (1 << 4)
	sll	t4, t4, 13
	sll	t5, t5, 12
	or	t2, t2, t4		# t2 |= ((lpo & (1 << 4)) << 13)
	or	t2, t2, t5		# t2 |= ((lpe & (1 << 4)) << 12)
	andi	t4, t3, (1 << 5)
	andi	t5, t6, (1 << 5)
	sll	t4, t4, 14
	sll	t5, t5, 13
	or	t2, t2, t4		# t2 |= ((lpo & (1 << 5)) << 14)
	or	t2, t2, t5		# t2 |= ((lpe & (1 << 5)) << 13)
	andi	t4, t3, (1 << 6)
	andi	t5, t6, (1 << 6)
	sll	t4, t4, 15
	sll	t5, t5, 14
	or	t2, t2, t4		# t2 |= ((lpo & (1 << 6)) << 15)
	or	t2, t2, t5		# t2 |= ((lpe & (1 << 6)) << 14)
	andi	t4, t3, (1 << 7)
	andi	t5, t6, (1 << 7)
	sll	t4, t4, 16
	sll	t5, t5, 15
	or	t2, t2, t4		# t2 |= ((lpo & (1 << 7)) << 16)
	or	t2, t2, t5		# t2 |= ((lpe & (1 << 7)) << 15)
	lui	v0, 0x00FF
	ori	v0, 0xFFFF
	jr	t9
	xor	v0, t2, v0

	.set	at
	.set	reorder

	.end	nand_ecc_generate


/******************************************************************************/
/******************************************************************************/

