/*
 * nxp_aes.h
 *
 * (C) Copyright 2008 Chris Steel, NXP Semiconductors
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef _NXP_AES_H_
#define _NXP_AES_H_

#include <adma.h>

#define AES_KEY_LENGTH 16
#define AES_IV_LENGTH  16

#define AES_MIN_BLOCK_SIZE 16

struct nxp_aes_op {

	void *src;
	void *dst;

	bool encrypt;
	bool hw_key;
	enum nxp_adma_aes_mode mode;
	int  len;

	u8 key[AES_KEY_LENGTH];
	u8 iv[AES_IV_LENGTH];
	u8 *next_iv;
};

#endif
