/**
 *
 * \file          tda1316_mk2.h
 * \version       1
 * \date          10-Oct-06
 * \Author        Guillot B.
 *
*/


#ifndef MAX3541_H
#define MAX3541_H

/*============================================================================*/
/*                       INCLUDE FILES                                        */
/*============================================================================*/
#include "dvb_frontend.h"


#ifdef __cplusplus
extern "C" {
#endif



/*============================================================================*/
/*                       MACRO DEFINITION                                     */
/*============================================================================*/
#ifndef FALSE
#define FALSE               0
#endif

#ifndef TRUE
#define TRUE                1
#endif

typedef unsigned long       DWORD;
//typedef int                 BOOL;	//bruce remove because it's defined in Max3541.c to avoid inflict with other file
/*============================================================================*/
/*                       ENUM OR TYPE DEFINITION                              */
/*============================================================================*/

/*============================================================================*/
/*                       EXTERN DATA DEFINITION                               */
/*============================================================================*/

/*============================================================================*/
/*                       EXTERN FUNCTION PROTOTYPES                           */
/*============================================================================*/
#if defined(CONFIG_DVB_MAX3541) || (defined(CONFIG_DVB_MAX3541_MODULE) && defined(MODULE))
struct dvb_frontend *
max3541_attach (
        struct dvb_frontend*    fe,
        u8 i2c_addr,
        struct i2c_adapter*     i2c
        );
#else
struct dvb_frontend *
max3541_attach (
        struct dvb_frontend*    fe,
        u8 i2c_addr,
        struct i2c_adapter*     i2c
        )
{
    printk(KERN_WARNING "%s: driver disabled by Kconfig\n", __FUNCTION__);
    return NULL;
}
#endif

void
I2C_IWriteByte(u8 offset,
               u8 data);

void
I2C_IWriteBlock(u8 offset,
                unsigned char * regs,
                u8 len);

void
I2C_IReadBlock(u8 offset,
               unsigned char * buf,
               u8 len);

#ifdef __cplusplus
}
#endif

#endif /* MAX3541_H */
/*============================================================================*/
/*                            END OF FILE                                     */
/*============================================================================*/
