/**
 *
 * \file          tda1316.h
 * \version       1
 * \date          10-Oct-06
 * \Author        Guillot B.
 *
*/


#ifndef TDA1316_H
#define TDA1316_H

/*============================================================================*/
/*                       INCLUDE FILES                                        */
/*============================================================================*/
#include "dvb_frontend.h"


#ifdef __cplusplus
extern "C" {
#endif



/*============================================================================*/
/*                       MACRO DEFINITION                                     */
/*============================================================================*/

/*============================================================================*/
/*                       ENUM OR TYPE DEFINITION                              */
/*============================================================================*/
enum td1316_type {
    TD1316_mkx, /* classic nxp tuner */
    DTT8D1T,    /* XuGuang DTT-8D1T  */
    TDQG4,      /* ALPS TDQG4        */
    DCT4C2,     /* XuGuang DCT-4C2   */
};

/*============================================================================*/
/*                       EXTERN DATA DEFINITION                               */
/*============================================================================*/




/*============================================================================*/
/*                       EXTERN FUNCTION PROTOTYPES                           */
/*============================================================================*/
#if defined(CONFIG_DVB_TD1316) || (defined(CONFIG_DVB_TD1316_MODULE) && defined(MODULE))
struct dvb_frontend * td1316_attach (
        struct dvb_frontend*    fe,
        u8 i2c_addr,
        struct i2c_adapter*     i2c,
        enum td1316_type        type
        );
#else
struct dvb_frontend * td1316_attach (
        struct dvb_frontend*    fe,
        u8 i2c_addr,
        struct i2c_adapter*     i2c,
        enum td1316_type        type
        )
{
    printk(KERN_WARNING "%s: driver disabled by Kconfig\n", __FUNCTION__);
    return NULL;
}
#endif

#ifdef __cplusplus
}
#endif

#endif /* TDA1316_H */
/*============================================================================*/
/*                            END OF FILE                                     */
/*============================================================================*/

