
#ifndef _STB225_GPIO_H_
#define _STB225_GPIO_H_

/*****************************************************************************
   GPIO definitions: by GPIO number
*****************************************************************************/

#define GPIO_0                  ((0 << 5) | ( 0 << 0))      /* PAD_AB3  : GPIO_0  : MIU_CSN1   :            : (O ) */
#define GPIO_1                  ((0 << 5) | ( 1 << 0))      /* PAD_AB2  : GPIO_1  : MIU_CSN2   :            : (O ) */
#define GPIO_2                  ((0 << 5) | ( 2 << 0))      /* PAD_J3   : GPIO_2  : MIU_LB     :            : (O ) */
#define GPIO_3                  ((0 << 5) | ( 3 << 0))      /* PAD_J4   : GPIO_3  : MIU_UB     :            : (O ) */
#define GPIO_4                  ((0 << 5) | ( 4 << 0))      /* PAD_AA2  : GPIO_4  : MIU_RDY    : IDE_IORDY  : (I ) */
#define GPIO_5                  ((0 << 5) | ( 5 << 0))      /* PAD_L4   : GPIO_5  : OUTPUT_HSM : IDE_DMREQ  : (IO) */
#define GPIO_6                  ((0 << 5) | ( 6 << 0))      /* PAD_H4   : GPIO_6  : VS_SD      : IDE_DMACK  : (IO) */
#define GPIO_7                  ((0 << 5) | ( 7 << 0))      /* PAD_E4   : GPIO_7  : HS_SD      : IDE_DIOR   : (IO) */
#define GPIO_8                  ((0 << 5) | ( 8 << 0))      /* PAD_D4   : GPIO_8  : VS_HD      : IDE_DIOW   : (IO) */
#define GPIO_9                  ((0 << 5) | ( 9 << 0))      /* PAD_D5   : GPIO_9  : HS_HD      : IDE_CS0    : (IO) */
#define GPIO_10                 ((0 << 5) | (10 << 0))      /* PAD_D6   : GPIO_10 : OUTPUT_VSM : IDE_CS1    : (IO) */
#define GPIO_11                 ((0 << 5) | (11 << 0))      /* PAD_D9   : GPIO_11 : FG0        :            : (IO) */
#define GPIO_12                 ((0 << 5) | (12 << 0))      /* PAD_AD26 : GPIO_12 : FG1        : SCK_IN     : (IO) */
#define GPIO_13                 ((0 << 5) | (13 << 0))      /* PAD_AE26 : GPIO_13 : FG2        :            : (IO) */
#define GPIO_14                 ((0 << 5) | (14 << 0))      /* PAD_AC1  : GPIO_14 : FG3        :            : (IO) */
#define GPIO_15                 ((0 << 5) | (15 << 0))      /* PAD_AB23 : GPIO_15 : FG4        :            : (IO) */
#define GPIO_16                 ((0 << 5) | (16 << 0))      /* PAD_AD1  : GPIO_16 : FG5        :            : (IO) */
#define GPIO_17                 ((0 << 5) | (17 << 0))      /* PAD_AC25 : GPIO_17 : FG6        : WS_IN      : (IO) */
#define GPIO_18                 ((0 << 5) | (18 << 0))      /* PAD_R23  : GPIO_18 : FG7        :            : (IO) */
#define GPIO_19                 ((0 << 5) | (19 << 0))      /* PAD_AC26 : GPIO_19 : FG8        :            : (IO) */
#define GPIO_20                 ((0 << 5) | (20 << 0))      /* PAD_G23  : GPIO_20 : FG9        : TR_CLK     : (IO) */
#define GPIO_21                 ((0 << 5) | (21 << 0))      /* PAD_C24  : GPIO_21 : FG10       : TR_DATA0   : (IO) */
#define GPIO_22                 ((0 << 5) | (22 << 0))      /* PAD_B26  : GPIO_22 : FG11       : TR_DATA1   : (IO) */
#define GPIO_23                 ((0 << 5) | (23 << 0))      /* PAD_D23  : GPIO_23 : CLK25M     : TR_DATA2   : (IO) */
#define GPIO_24                 ((0 << 5) | (24 << 0))      /* PAD_F24  : GPIO_24 : CLK25M     : TR_DATA3   : (IO) */
#define GPIO_25                 ((0 << 5) | (25 << 0))      /* PAD_C20  : GPIO_25 : USB_PWE    : TR_DATA4   : (O ) */
#define GPIO_26                 ((0 << 5) | (26 << 0))      /* PAD_C21  : GPIO_26 : USB_FLG    : TR_DATA5   : (I ) */
#define GPIO_27                 ((0 << 5) | (27 << 0))      /* PAD_G2   : GPIO_27 : ETH_TXD2   :            : (O ) */
#define GPIO_28                 ((0 << 5) | (28 << 0))      /* PAD_G1   : GPIO_28 : ETH_TXD3   :            : (O ) */
#define GPIO_29                 ((0 << 5) | (29 << 0))      /* PAD_H1   : GPIO_29 : ETH_TXER   :            : (O ) */
#define GPIO_30                 ((0 << 5) | (30 << 0))      /* PAD_E2   : GPIO_30 : ETH_RXD2   :            : (I ) */
#define GPIO_31                 ((0 << 5) | (31 << 0))      /* PAD_E1   : GPIO_31 : ETH_RXD3   :            : (I ) */
#define GPIO_32                 ((1 << 5) | ( 0 << 0))      /* PAD_D2   : GPIO_32 : ETH_RXDV   :            : (I ) */
#define GPIO_33                 ((1 << 5) | ( 1 << 0))      /* PAD_H2   : GPIO_33 : ETH_COL    :            : (I ) */
#define GPIO_34                 ((1 << 5) | ( 2 << 0))      /* PAD_D24  : GPIO_34 : UART1_DCD  : TR_DATA6   : (I ) */
#define GPIO_35                 ((1 << 5) | ( 3 << 0))      /* PAD_D25  : GPIO_35 : UART1_DTR  : TR_DATA7   : (O ) */
#define GPIO_36                 ((1 << 5) | ( 4 << 0))      /* PAD_D26  : GPIO_36 : UART1_CTS  :            : (I ) */
#define GPIO_37                 ((1 << 5) | ( 5 << 0))      /* PAD_E24  : GPIO_37 : UART1_RTS  :            : (O ) */
#define GPIO_38                 ((1 << 5) | ( 6 << 0))      /* PAD_AB24 : GPIO_38 : IR0_DOUT   :            : (O ) */
#define GPIO_39                 ((1 << 5) | ( 7 << 0))      /* PAD_AB25 : GPIO_39 : IR1_DIN    :            : (I ) */
#define GPIO_40                 ((1 << 5) | ( 8 << 0))      /* PAD_AB26 : GPIO_40 : IR1_DOUT   :            : (O ) */
#define GPIO_41                 ((1 << 5) | ( 9 << 0))      /* PAD_V26  : GPIO_41 : SC1_DA     :            : (IO) */
#define GPIO_42                 ((1 << 5) | (10 << 0))      /* PAD_AA25 : GPIO_42 : SC1_OFF    :            : (I ) */
#define GPIO_43                 ((1 << 5) | (11 << 0))      /* PAD_AA26 : GPIO_43 : SC1_RST    :            : (O ) */
#define GPIO_44                 ((1 << 5) | (12 << 0))      /* PAD_H25  : GPIO_44 : TS2_DATA1  :            : (IO) */
#define GPIO_45                 ((1 << 5) | (13 << 0))      /* PAD_H26  : GPIO_45 : TS2_DATA2  :            : (IO) */
#define GPIO_46                 ((1 << 5) | (14 << 0))      /* PAD_J24  : GPIO_46 : TS2_DATA3  :            : (IO) */
#define GPIO_47                 ((1 << 5) | (15 << 0))      /* PAD_J25  : GPIO_47 : TS2_DATA4  :            : (IO) */
#define GPIO_48                 ((1 << 5) | (16 << 0))      /* PAD_J26  : GPIO_48 : TS2_DATA5  :            : (IO) */
#define GPIO_49                 ((1 << 5) | (17 << 0))      /* PAD_K24  : GPIO_49 : TS2_DATA6  :            : (IO) */
#define GPIO_50                 ((1 << 5) | (18 << 0))      /* PAD_K25  : GPIO_50 : TS2_DATA7  :            : (IO) */
#define GPIO_51                 ((1 << 5) | (19 << 0))      /* PAD_C11  : GPIO_51 : SD1_OUT1   :            : (O ) */
#define GPIO_52                 ((1 << 5) | (20 << 0))      /* PAD_B11  : GPIO_52 : SD1_OUT2   :            : (O ) */
#define GPIO_53                 ((1 << 5) | (21 << 0))      /* PAD_D10  : GPIO_53 : SD1_OUT3   :            : (O ) */

#define GPIO_NULL               ((1 << 5) | (31 << 0))      /* no external pad... */


/*****************************************************************************
   GPIO definitions: by pad name
*****************************************************************************/

#define GPIO_PAD_AA2            ((0 << 5) | ( 4 << 0))      /* PAD_AA2  : GPIO_4  : MIU_RDY    : IDE_IORDY  : (I ) */
#define GPIO_PAD_AA25           ((1 << 5) | (10 << 0))      /* PAD_AA25 : GPIO_42 : SC1_OFF    :            : (I ) */
#define GPIO_PAD_AA26           ((1 << 5) | (11 << 0))      /* PAD_AA26 : GPIO_43 : SC1_RST    :            : (O ) */
#define GPIO_PAD_AB2            ((0 << 5) | ( 1 << 0))      /* PAD_AB2  : GPIO_1  : MIU_CSN2   :            : (O ) */
#define GPIO_PAD_AB23           ((0 << 5) | (15 << 0))      /* PAD_AB23 : GPIO_15 : FG4        :            : (IO) */
#define GPIO_PAD_AB24           ((1 << 5) | ( 6 << 0))      /* PAD_AB24 : GPIO_38 : IR0_DOUT   :            : (O ) */
#define GPIO_PAD_AB25           ((1 << 5) | ( 7 << 0))      /* PAD_AB25 : GPIO_39 : IR1_DIN    :            : (I ) */
#define GPIO_PAD_AB26           ((1 << 5) | ( 8 << 0))      /* PAD_AB26 : GPIO_40 : IR1_DOUT   :            : (O ) */
#define GPIO_PAD_AB3            ((0 << 5) | ( 0 << 0))      /* PAD_AB3  : GPIO_0  : MIU_CSN1   :            : (O ) */
#define GPIO_PAD_AC1            ((0 << 5) | (14 << 0))      /* PAD_AC1  : GPIO_14 : FG3        :            : (IO) */
#define GPIO_PAD_AC25           ((0 << 5) | (17 << 0))      /* PAD_AC25 : GPIO_17 : FG6        : WS_IN      : (IO) */
#define GPIO_PAD_AC26           ((0 << 5) | (19 << 0))      /* PAD_AC26 : GPIO_19 : FG8        :            : (IO) */
#define GPIO_PAD_AD1            ((0 << 5) | (16 << 0))      /* PAD_AD1  : GPIO_16 : FG5        :            : (IO) */
#define GPIO_PAD_AD26           ((0 << 5) | (12 << 0))      /* PAD_AD26 : GPIO_12 : FG1        : SCK_IN     : (IO) */
#define GPIO_PAD_AE26           ((0 << 5) | (13 << 0))      /* PAD_AE26 : GPIO_13 : FG2        :            : (IO) */
#define GPIO_PAD_B11            ((1 << 5) | (20 << 0))      /* PAD_B11  : GPIO_52 : SD1_OUT2   :            : (O ) */
#define GPIO_PAD_B26            ((0 << 5) | (22 << 0))      /* PAD_B26  : GPIO_22 : FG11       : TR_DATA1   : (IO) */
#define GPIO_PAD_C11            ((1 << 5) | (19 << 0))      /* PAD_C11  : GPIO_51 : SD1_OUT1   :            : (O ) */
#define GPIO_PAD_C20            ((0 << 5) | (25 << 0))      /* PAD_C20  : GPIO_25 : USB_PWE    : TR_DATA4   : (O ) */
#define GPIO_PAD_C21            ((0 << 5) | (26 << 0))      /* PAD_C21  : GPIO_26 : USB_FLG    : TR_DATA5   : (I ) */
#define GPIO_PAD_C24            ((0 << 5) | (21 << 0))      /* PAD_C24  : GPIO_21 : FG10       : TR_DATA0   : (IO) */
#define GPIO_PAD_D10            ((1 << 5) | (21 << 0))      /* PAD_D10  : GPIO_53 : SD1_OUT3   :            : (O ) */
#define GPIO_PAD_D2             ((1 << 5) | ( 0 << 0))      /* PAD_D2   : GPIO_32 : ETH_RXDV   :            : (I ) */
#define GPIO_PAD_D23            ((0 << 5) | (23 << 0))      /* PAD_D23  : GPIO_23 : CLK25M     : TR_DATA2   : (IO) */
#define GPIO_PAD_D24            ((1 << 5) | ( 2 << 0))      /* PAD_D24  : GPIO_34 : UART1_DCD  : TR_DATA6   : (I ) */
#define GPIO_PAD_D25            ((1 << 5) | ( 3 << 0))      /* PAD_D25  : GPIO_35 : UART1_DTR  : TR_DATA7   : (O ) */
#define GPIO_PAD_D26            ((1 << 5) | ( 4 << 0))      /* PAD_D26  : GPIO_36 : UART1_CTS  :            : (I ) */
#define GPIO_PAD_D4             ((0 << 5) | ( 8 << 0))      /* PAD_D4   : GPIO_8  : VS_HD      : IDE_DIOW   : (IO) */
#define GPIO_PAD_D5             ((0 << 5) | ( 9 << 0))      /* PAD_D5   : GPIO_9  : HS_HD      : IDE_CS0    : (IO) */
#define GPIO_PAD_D6             ((0 << 5) | (10 << 0))      /* PAD_D6   : GPIO_10 : OUTPUT_VSM : IDE_CS1    : (IO) */
#define GPIO_PAD_D9             ((0 << 5) | (11 << 0))      /* PAD_D9   : GPIO_11 : FG0        :            : (IO) */
#define GPIO_PAD_E1             ((0 << 5) | (31 << 0))      /* PAD_E1   : GPIO_31 : ETH_RXD3   :            : (I ) */
#define GPIO_PAD_E2             ((0 << 5) | (30 << 0))      /* PAD_E2   : GPIO_30 : ETH_RXD2   :            : (I ) */
#define GPIO_PAD_E24            ((1 << 5) | ( 5 << 0))      /* PAD_E24  : GPIO_37 : UART1_RTS  :            : (O ) */
#define GPIO_PAD_E4             ((0 << 5) | ( 7 << 0))      /* PAD_E4   : GPIO_7  : HS_SD      : IDE_DIOR   : (IO) */
#define GPIO_PAD_F24            ((0 << 5) | (24 << 0))      /* PAD_F24  : GPIO_24 : CLK25M     : TR_DATA3   : (IO) */
#define GPIO_PAD_G1             ((0 << 5) | (28 << 0))      /* PAD_G1   : GPIO_28 : ETH_TXD3   :            : (O ) */
#define GPIO_PAD_G2             ((0 << 5) | (27 << 0))      /* PAD_G2   : GPIO_27 : ETH_TXD2   :            : (O ) */
#define GPIO_PAD_G23            ((0 << 5) | (20 << 0))      /* PAD_G23  : GPIO_20 : FG9        : TR_CLK     : (IO) */
#define GPIO_PAD_H1             ((0 << 5) | (29 << 0))      /* PAD_H1   : GPIO_29 : ETH_TXER   :            : (O ) */
#define GPIO_PAD_H2             ((1 << 5) | ( 1 << 0))      /* PAD_H2   : GPIO_33 : ETH_COL    :            : (I ) */
#define GPIO_PAD_H25            ((1 << 5) | (12 << 0))      /* PAD_H25  : GPIO_44 : TS2_DATA1  :            : (IO) */
#define GPIO_PAD_H26            ((1 << 5) | (13 << 0))      /* PAD_H26  : GPIO_45 : TS2_DATA2  :            : (IO) */
#define GPIO_PAD_H4             ((0 << 5) | ( 6 << 0))      /* PAD_H4   : GPIO_6  : VS_SD      : IDE_DMACK  : (IO) */
#define GPIO_PAD_J24            ((1 << 5) | (14 << 0))      /* PAD_J24  : GPIO_46 : TS2_DATA3  :            : (IO) */
#define GPIO_PAD_J25            ((1 << 5) | (15 << 0))      /* PAD_J25  : GPIO_47 : TS2_DATA4  :            : (IO) */
#define GPIO_PAD_J26            ((1 << 5) | (16 << 0))      /* PAD_J26  : GPIO_48 : TS2_DATA5  :            : (IO) */
#define GPIO_PAD_J3             ((0 << 5) | ( 2 << 0))      /* PAD_J3   : GPIO_2  : MIU_LB     :            : (O ) */
#define GPIO_PAD_J4             ((0 << 5) | ( 3 << 0))      /* PAD_J4   : GPIO_3  : MIU_UB     :            : (O ) */
#define GPIO_PAD_K24            ((1 << 5) | (17 << 0))      /* PAD_K24  : GPIO_49 : TS2_DATA6  :            : (IO) */
#define GPIO_PAD_K25            ((1 << 5) | (18 << 0))      /* PAD_K25  : GPIO_50 : TS2_DATA7  :            : (IO) */
#define GPIO_PAD_L4             ((0 << 5) | ( 5 << 0))      /* PAD_L4   : GPIO_5  : OUTPUT_HSM : IDE_DMREQ  : (IO) */
#define GPIO_PAD_R23            ((0 << 5) | (18 << 0))      /* PAD_R23  : GPIO_18 : FG7        :            : (IO) */
#define GPIO_PAD_V26            ((1 << 5) | ( 9 << 0))      /* PAD_V26  : GPIO_41 : SC1_DA     :            : (IO) */


/*****************************************************************************
   GPIO definitions: by alternative function
*****************************************************************************/

#define GPIO_ETH_COL            ((1 << 5) | ( 1 << 0))      /* PAD_H2   : GPIO_33 : ETH_COL    :            : (I ) */
#define GPIO_ETH_RXD2           ((0 << 5) | (30 << 0))      /* PAD_E2   : GPIO_30 : ETH_RXD2   :            : (I ) */
#define GPIO_ETH_RXD3           ((0 << 5) | (31 << 0))      /* PAD_E1   : GPIO_31 : ETH_RXD3   :            : (I ) */
#define GPIO_ETH_RXDV           ((1 << 5) | ( 0 << 0))      /* PAD_D2   : GPIO_32 : ETH_RXDV   :            : (I ) */
#define GPIO_ETH_TXD2           ((0 << 5) | (27 << 0))      /* PAD_G2   : GPIO_27 : ETH_TXD2   :            : (O ) */
#define GPIO_ETH_TXD3           ((0 << 5) | (28 << 0))      /* PAD_G1   : GPIO_28 : ETH_TXD3   :            : (O ) */
#define GPIO_ETH_TXER           ((0 << 5) | (29 << 0))      /* PAD_H1   : GPIO_29 : ETH_TXER   :            : (O ) */
#define GPIO_FG0                ((0 << 5) | (11 << 0))      /* PAD_D9   : GPIO_11 : FG0        :            : (IO) */
#define GPIO_FG10               ((0 << 5) | (21 << 0))      /* PAD_C24  : GPIO_21 : FG10       : TR_DATA0   : (IO) */
#define GPIO_FG1                ((0 << 5) | (12 << 0))      /* PAD_AD26 : GPIO_12 : FG1        : SCK_IN     : (IO) */
#define GPIO_FG11               ((0 << 5) | (22 << 0))      /* PAD_B26  : GPIO_22 : FG11       : TR_DATA1   : (IO) */
#define GPIO_FG2                ((0 << 5) | (13 << 0))      /* PAD_AE26 : GPIO_13 : FG2        :            : (IO) */
#define GPIO_FG3                ((0 << 5) | (14 << 0))      /* PAD_AC1  : GPIO_14 : FG3        :            : (IO) */
#define GPIO_FG4                ((0 << 5) | (15 << 0))      /* PAD_AB23 : GPIO_15 : FG4        :            : (IO) */
#define GPIO_FG5                ((0 << 5) | (16 << 0))      /* PAD_AD1  : GPIO_16 : FG5        :            : (IO) */
#define GPIO_FG6                ((0 << 5) | (17 << 0))      /* PAD_AC25 : GPIO_17 : FG6        : WS_IN      : (IO) */
#define GPIO_FG7                ((0 << 5) | (18 << 0))      /* PAD_R23  : GPIO_18 : FG7        :            : (IO) */
#define GPIO_FG8                ((0 << 5) | (19 << 0))      /* PAD_AC26 : GPIO_19 : FG8        :            : (IO) */
#define GPIO_FG9                ((0 << 5) | (20 << 0))      /* PAD_G23  : GPIO_20 : FG9        : TR_CLK     : (IO) */
#define GPIO_HS_HD              ((0 << 5) | ( 9 << 0))      /* PAD_D5   : GPIO_9  : HS_HD      : IDE_CS0    : (IO) */
#define GPIO_HS_SD              ((0 << 5) | ( 7 << 0))      /* PAD_E4   : GPIO_7  : HS_SD      : IDE_DIOR   : (IO) */
#define GPIO_IDE_CS0            ((0 << 5) | ( 9 << 0))      /* PAD_D5   : GPIO_9  : HS_HD      : IDE_CS0    : (IO) */
#define GPIO_IDE_CS1            ((0 << 5) | (10 << 0))      /* PAD_D6   : GPIO_10 : OUTPUT_VSM : IDE_CS1    : (IO) */
#define GPIO_IDE_DIOR           ((0 << 5) | ( 7 << 0))      /* PAD_E4   : GPIO_7  : HS_SD      : IDE_DIOR   : (IO) */
#define GPIO_IDE_DIOW           ((0 << 5) | ( 8 << 0))      /* PAD_D4   : GPIO_8  : VS_HD      : IDE_DIOW   : (IO) */
#define GPIO_IDE_DMACK          ((0 << 5) | ( 6 << 0))      /* PAD_H4   : GPIO_6  : VS_SD      : IDE_DMACK  : (IO) */
#define GPIO_IDE_DMREQ          ((0 << 5) | ( 5 << 0))      /* PAD_L4   : GPIO_5  : OUTPUT_HSM : IDE_DMREQ  : (IO) */
#define GPIO_IDE_IORDY          ((0 << 5) | ( 4 << 0))      /* PAD_AA2  : GPIO_4  : MIU_RDY    : IDE_IORDY  : (I ) */
#define GPIO_IR0_DOUT           ((1 << 5) | ( 6 << 0))      /* PAD_AB24 : GPIO_38 : IR0_DOUT   :            : (O ) */
#define GPIO_IR1_DIN            ((1 << 5) | ( 7 << 0))      /* PAD_AB25 : GPIO_39 : IR1_DIN    :            : (I ) */
#define GPIO_IR1_DOUT           ((1 << 5) | ( 8 << 0))      /* PAD_AB26 : GPIO_40 : IR1_DOUT   :            : (O ) */
#define GPIO_MIU_CSN1           ((0 << 5) | ( 0 << 0))      /* PAD_AB3  : GPIO_0  : MIU_CSN1   :            : (O ) */
#define GPIO_MIU_CSN2           ((0 << 5) | ( 1 << 0))      /* PAD_AB2  : GPIO_1  : MIU_CSN2   :            : (O ) */
#define GPIO_MIU_LB             ((0 << 5) | ( 2 << 0))      /* PAD_J3   : GPIO_2  : MIU_LB     :            : (O ) */
#define GPIO_MIU_RDY            ((0 << 5) | ( 4 << 0))      /* PAD_AA2  : GPIO_4  : MIU_RDY    : IDE_IORDY  : (I ) */
#define GPIO_MIU_UB             ((0 << 5) | ( 3 << 0))      /* PAD_J4   : GPIO_3  : MIU_UB     :            : (O ) */
#define GPIO_OUTPUT_HSM         ((0 << 5) | ( 5 << 0))      /* PAD_L4   : GPIO_5  : OUTPUT_HSM : IDE_DMREQ  : (IO) */
#define GPIO_OUTPUT_VSM         ((0 << 5) | (10 << 0))      /* PAD_D6   : GPIO_10 : OUTPUT_VSM : IDE_CS1    : (IO) */
#define GPIO_SC1_DA             ((1 << 5) | ( 9 << 0))      /* PAD_V26  : GPIO_41 : SC1_DA     :            : (IO) */
#define GPIO_SC1_OFF            ((1 << 5) | (10 << 0))      /* PAD_AA25 : GPIO_42 : SC1_OFF    :            : (I ) */
#define GPIO_SC1_RST            ((1 << 5) | (11 << 0))      /* PAD_AA26 : GPIO_43 : SC1_RST    :            : (O ) */
#define GPIO_SCK_IN             ((0 << 5) | (12 << 0))      /* PAD_AD26 : GPIO_12 : FG1        : SCK_IN     : (IO) */
#define GPIO_SD1_OUT1           ((1 << 5) | (19 << 0))      /* PAD_C11  : GPIO_51 : SD1_OUT1   :            : (O ) */
#define GPIO_SD1_OUT2           ((1 << 5) | (20 << 0))      /* PAD_B11  : GPIO_52 : SD1_OUT2   :            : (O ) */
#define GPIO_SD1_OUT3           ((1 << 5) | (21 << 0))      /* PAD_D10  : GPIO_53 : SD1_OUT3   :            : (O ) */
#define GPIO_TR_CLK             ((0 << 5) | (20 << 0))      /* PAD_G23  : GPIO_20 : FG9        : TR_CLK     : (IO) */
#define GPIO_TR_DATA0           ((0 << 5) | (21 << 0))      /* PAD_C24  : GPIO_21 : FG10       : TR_DATA0   : (IO) */
#define GPIO_TR_DATA1           ((0 << 5) | (22 << 0))      /* PAD_B26  : GPIO_22 : FG11       : TR_DATA1   : (IO) */
#define GPIO_TR_DATA2           ((0 << 5) | (23 << 0))      /* PAD_D23  : GPIO_23 : CLK25M     : TR_DATA2   : (IO) */
#define GPIO_TR_DATA3           ((0 << 5) | (24 << 0))      /* PAD_F24  : GPIO_24 : CLK25M     : TR_DATA3   : (IO) */
#define GPIO_TR_DATA4           ((0 << 5) | (25 << 0))      /* PAD_C20  : GPIO_25 : USB_PWE    : TR_DATA4   : (O ) */
#define GPIO_TR_DATA5           ((0 << 5) | (26 << 0))      /* PAD_C21  : GPIO_26 : USB_FLG    : TR_DATA5   : (I ) */
#define GPIO_TR_DATA6           ((1 << 5) | ( 2 << 0))      /* PAD_D24  : GPIO_34 : UART1_DCD  : TR_DATA6   : (I ) */
#define GPIO_TR_DATA7           ((1 << 5) | ( 3 << 0))      /* PAD_D25  : GPIO_35 : UART1_DTR  : TR_DATA7   : (O ) */
#define GPIO_TS2_DATA1          ((1 << 5) | (12 << 0))      /* PAD_H25  : GPIO_44 : TS2_DATA1  :            : (IO) */
#define GPIO_TS2_DATA2          ((1 << 5) | (13 << 0))      /* PAD_H26  : GPIO_45 : TS2_DATA2  :            : (IO) */
#define GPIO_TS2_DATA3          ((1 << 5) | (14 << 0))      /* PAD_J24  : GPIO_46 : TS2_DATA3  :            : (IO) */
#define GPIO_TS2_DATA4          ((1 << 5) | (15 << 0))      /* PAD_J25  : GPIO_47 : TS2_DATA4  :            : (IO) */
#define GPIO_TS2_DATA5          ((1 << 5) | (16 << 0))      /* PAD_J26  : GPIO_48 : TS2_DATA5  :            : (IO) */
#define GPIO_TS2_DATA6          ((1 << 5) | (17 << 0))      /* PAD_K24  : GPIO_49 : TS2_DATA6  :            : (IO) */
#define GPIO_TS2_DATA7          ((1 << 5) | (18 << 0))      /* PAD_K25  : GPIO_50 : TS2_DATA7  :            : (IO) */
#define GPIO_UART1_CTS          ((1 << 5) | ( 4 << 0))      /* PAD_D26  : GPIO_36 : UART1_CTS  :            : (I ) */
#define GPIO_UART1_DCD          ((1 << 5) | ( 2 << 0))      /* PAD_D24  : GPIO_34 : UART1_DCD  : TR_DATA6   : (I ) */
#define GPIO_UART1_DTR          ((1 << 5) | ( 3 << 0))      /* PAD_D25  : GPIO_35 : UART1_DTR  : TR_DATA7   : (O ) */
#define GPIO_UART1_RTS          ((1 << 5) | ( 5 << 0))      /* PAD_E24  : GPIO_37 : UART1_RTS  :            : (O ) */
#define GPIO_USB_FLG            ((0 << 5) | (26 << 0))      /* PAD_C21  : GPIO_26 : USB_FLG    : TR_DATA5   : (I ) */
#define GPIO_USB_PWE            ((0 << 5) | (25 << 0))      /* PAD_C20  : GPIO_25 : USB_PWE    : TR_DATA4   : (O ) */
#define GPIO_VS_HD              ((0 << 5) | ( 8 << 0))      /* PAD_D4   : GPIO_8  : VS_HD      : IDE_DIOW   : (IO) */
#define GPIO_VS_SD              ((0 << 5) | ( 6 << 0))      /* PAD_H4   : GPIO_6  : VS_SD      : IDE_DMACK  : (IO) */
#define GPIO_WS_IN              ((0 << 5) | (17 << 0))      /* PAD_AC25 : GPIO_17 : FG6        : WS_IN      : (IO) */


/*****************************************************************************
*****************************************************************************/

typedef unsigned char gpio_pin_t;

extern int gpio_is_input (gpio_pin_t pin);
extern void gpio_set_as_input (gpio_pin_t pin);
extern void gpio_set_as_output (gpio_pin_t pin, int initial_value);
extern void gpio_set_high (gpio_pin_t pin);
extern void gpio_set_low (gpio_pin_t pin);
extern void gpio_set_as_function (gpio_pin_t pin);
extern unsigned int gpio_get_value (gpio_pin_t pin);

#endif

