/*
 * (C) Copyright 2007 Andre McCurdy, NXP Semiconductors
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#define zero	$0
#define AT	$1

#define v0 	$2
#define v1	$3

#define a0	$4
#define a1	$5
#define a2	$6
#define	a3	$7

#define t0	$8
#define t1	$9
#define t2	$10
#define t3	$11
#define t4	$12
#define t5	$13
#define t6	$14
#define t7	$15

#define s0	$16
#define s1	$17
#define s2	$18
#define s3	$19
#define s4	$20
#define s5	$21
#define s6	$22
#define s7	$23
#define s8	$30		/* == fp */

#define t8	$24
#define t9	$25

#define k0	$26
#define k1	$27

#define gp	$28
#define sp	$29
#define fp	$30		/* == s8 */
#define ra	$31

/******************************************************************************/
/******************************************************************************/

#if (defined (__MIPSEB__) && ! defined (__MIPSEL__))

#define CPU_TO_BE32(x,t)

#elif (defined (__MIPSEL__) && ! defined (__MIPSEB__))

#define CPU_TO_BE32(x,t)	wsbh t,x; ror x,t,16

#else
#error "__MIPSEL__ or __MIPSEB__ must be defined"
#endif

#define STATE4_IN_AT


/******************************************************************************/
/******************************************************************************/

	.text

	.align  4	# 2^4 == 16 byte initial alignment

	.globl  SHA1_Transform_asm
	.ent    SHA1_Transform_asm
	.type   SHA1_Transform_asm, @function

	#
	# void SHA1_Transform (unsigned int *state, unsigned int *in, unsigned int iterations)
	#

SHA1_Transform_asm:

	.set    noreorder
	.set    nomacro
	.set    noat


/******************************************************************************/
/******************************************************************************/
#if defined (STATE4_IN_AT)
/******************************************************************************/
/******************************************************************************/

	#
	#    ----------------------
	#   | oabi a3 : ignore
	#    ---------------------- 72
	#   | oabi a2 : ignore
	#    ---------------------- 68
	#   | oabi a1 : ignore
	#    ---------------------- 64
	#   | oabi a0 : ignore
	# ========================= 60
	#   | ra
	#    ---------------------- 56
	#   | s8
	#    ---------------------- 52
	#   | s7
	#    ---------------------- 48
	#   | s6
	#    ---------------------- 44
	#   | s5
	#    ---------------------- 40
	#   | s4
	#    ---------------------- 36
	#   | s3
	#    ---------------------- 32
	#   | s2
	#    ---------------------- 28
	#   | s1
	#    ---------------------- 24
	#   | s0
	#    ---------------------- 20
	#   | &state[0]
	#    ---------------------- 16
	#   | state3
	#    ---------------------- 12
	#   | state2
	#    ---------------------- 8
	#   | state1
	#    ---------------------- 4
	#   | state0
	#    ---------------------- 0
	#

#define SF_SIZE		60

#define SPO_RA		56(sp)
#define SPO_S8		52(sp)
#define SPO_S7		48(sp)
#define SPO_S6		44(sp)
#define SPO_S5		40(sp)
#define SPO_S4		36(sp)
#define SPO_S3		32(sp)
#define SPO_S2		28(sp)
#define SPO_S1		24(sp)
#define SPO_S0		20(sp)
#define SPO_STATE	16(sp)
#define SPO_STATE3	12(sp)
#define SPO_STATE2	 8(sp)
#define SPO_STATE1	 4(sp)
#define SPO_STATE0	 0(sp)

/******************************************************************************/
/******************************************************************************/
#else
/******************************************************************************/
/******************************************************************************/

	#
	#    ----------------------
	#   | oabi a3 : ignore
	#    ---------------------- 76
	#   | oabi a2 : ignore
	#    ---------------------- 72
	#   | oabi a1 : ignore
	#    ---------------------- 68
	#   | oabi a0 : ignore
	# ========================= 64
	#   | ra
	#    ---------------------- 60
	#   | s8
	#    ---------------------- 56
	#   | s7
	#    ---------------------- 52
	#   | s6
	#    ---------------------- 48
	#   | s5
	#    ---------------------- 44
	#   | s4
	#    ---------------------- 40
	#   | s3
	#    ---------------------- 36
	#   | s2
	#    ---------------------- 32
	#   | s1
	#    ---------------------- 28
	#   | s0
	#    ---------------------- 24
	#   | &state[0]
	#    ---------------------- 20
	#   | state4
	#    ---------------------- 16
	#   | state3
	#    ---------------------- 12
	#   | state2
	#    ---------------------- 8
	#   | state1
	#    ---------------------- 4
	#   | state0
	#    ---------------------- 0
	#

#define SF_SIZE		64

#define SPO_RA		60(sp)
#define SPO_S8		56(sp)
#define SPO_S7		52(sp)
#define SPO_S6		48(sp)
#define SPO_S5		44(sp)
#define SPO_S4		40(sp)
#define SPO_S3		36(sp)
#define SPO_S2		32(sp)
#define SPO_S1		28(sp)
#define SPO_S0		24(sp)
#define SPO_STATE	20(sp)
#define SPO_STATE4	16(sp)
#define SPO_STATE3	12(sp)
#define SPO_STATE2	 8(sp)
#define SPO_STATE1	 4(sp)
#define SPO_STATE0	 0(sp)

/******************************************************************************/
/******************************************************************************/
#endif
/******************************************************************************/
/******************************************************************************/


				    # a0 = &state[0]
				    # a1 = in
				    # a2 = iterations

	beqz    a2, 2f              # if (iterations == 0) return
	addiu   sp, sp, -SF_SIZE    # (bdslot) create stack frame

	sw      a0, SPO_STATE       # state pointer -> stack

	sw      s0, SPO_S0	    # s0 -> stack
	sw      s1, SPO_S1	    # s1 -> stack
	sw      s2, SPO_S2	    # s2 -> stack
	sw      s3, SPO_S3	    # s3 -> stack
	sw      s4, SPO_S4	    # s4 -> stack
	sw      s5, SPO_S5	    # s5 -> stack
	sw      s6, SPO_S6	    # s6 -> stack
	sw      s7, SPO_S7	    # s7 -> stack
	sw      s8, SPO_S8	    # s8 -> stack
	sw      ra, SPO_RA          # ra -> stack

	lw      t0, 0(a0)           # t0 = A = state[0]
	lw      t1, 4(a0)           # t1 = B = state[1]
	lw      t2, 8(a0)           # t2 = C = state[2]
	lw      t3, 12(a0)          # t3 = D = state[3]
	lw      t4, 16(a0)          # t4 = E = state[4]

	move    ra, a2              # ra = iterations remaining
	move    ra, a2              # ra = iterations remaining

	#-------------------------------------------------------------
	# 
	# Per main loop iteration : 325 addu
	#                           312 xor
	#                           224 ror
	#                            60 and
	#                            40 or
	#                            20 lw (16 input data + 4 state)
	#                            11 lui
	#                            11 ori
	#                             4 sw (state)
	#                             2 addiu
	#                             1 move
	#                             1 bne
	#                          -----------------
	#     Total (mipseb)       1011
	#
	#                            16 ror
	#                            16 wsbh
	#                          -----------------
	#     Total (mipsel)       1043
	#
	#-------------------------------------------------------------

1:	sw      t0, SPO_STATE0      # state0 -> stack
	sw      t1, SPO_STATE1      # state1 -> stack
	sw      t2, SPO_STATE2      # state2 -> stack
	sw      t3, SPO_STATE3      # state3 -> stack
#if defined (STATE4_IN_AT)
	move    AT, t4              # AT = state4
#else
	sw      t4, SPO_STATE4      # state4 -> stack
#endif
	lw      t8, 0(a1)           # t8 = in[0]
	xor     v1, t2, t3          # v1 =   (C ^ D)
	and     v1, v1, t1          # v1 =  ((C ^ D) & B)
	xor     v1, v1, t3          # v1 = (((C ^ D) & B) ^ D)
	CPU_TO_BE32(t8, v0)         # t8 = x[0]
	lw      t9, 4(a1)           # t9 = in[1]
	ror     a3, t0, 27          # a3 = A (rotate left 5)
	addu    a3, a3, v1          # a3 = A (rotate left 5) + (((C ^ D) & B) ^ D)
	addu    a3, a3, t8          # a3 = A (rotate left 5) + (((C ^ D) & B) ^ D) + x[0]
	ror     t1, t1, 2           # B  = B (rotate left 30)
	CPU_TO_BE32(t9, v0)         # t9 = x[1]
	addu    a3, t4, a3          # a3 = A (rotate left 5) + (((C ^ D) & B) ^ D) + x[0] + E
	lui     t4, 0x5a82          #
	ori     t4, t4, 0x7999      # t4 = K1
	xor     v1, t1, t2          # v1 =   (B ^ C)
	lw      s7, 8(a1)           # s7 = in[2]
	addu    a3, a3, t4          # a3 = A (rotate left 5) + (((C ^ D) & B) ^ D) + x[0] + E + K1
	and     v1, v1, t0          #
	xor     v1, v1, t2          #
	ror     a2, a3, 27          #
	addu    a2, a2, v1          #
	ror     t0, t0, 2           #
	addu    a2, a2, t9          #
	CPU_TO_BE32(s7, v0)         # s7 = x[2]
	xor     v1, t0, t1          #
	addu    a2, t3, a2          #
	lw      s6, 12(a1)          # s6 = in[3]
	addu    a2, a2, t4          #
	and     v1, v1, a3          #
	xor     v1, v1, t1          #
	ror     s8, a2, 27          #
	addu    s8, s8, v1          #
	ror     a3, a3, 2           #
	addu    s8, s8, s7          #
	CPU_TO_BE32(s6, v0)         # s6 = x[3]
	xor     t3, a3, t0          #
	addu    s8, t2, s8          #
	lw      s5, 16(a1)          # s5 = in[4]
	addu    s8, s8, t4          #
	and     t3, t3, a2          #
	xor     t3, t3, t0          #
	ror     v1, s8, 27          #
	addu    v1, v1, t3          #
	ror     a2, a2, 2           #
	addu    v1, v1, s6          #
	CPU_TO_BE32(s5, v0)         # s5 = x[4]
	xor     t3, a2, a3          #
	addu    t1, t1, v1          #
	lw      s4, 20(a1)          # s4 = in[5]
	addu    t1, t1, t4          #
	and     t3, t3, s8          #
	xor     t3, t3, a3          #
	ror     v1, t1, 27          #
	addu    v1, v1, t3          #
	ror     s8, s8, 2           #
	addu    v1, v1, s5          #
	CPU_TO_BE32(s4, v0)         # s4 = x[5]
	xor     t3, s8, a2          #
	addu    t0, t0, v1          #
	lw      s3, 24(a1)          # s3 = in[6]
	addu    t0, t0, t4          #
	and     t3, t3, t1          #
	xor     t3, t3, a2          #
	ror     v1, t0, 27          #
	addu    v1, v1, t3          #
	ror     t1, t1, 2           #
	addu    v1, v1, s4          #
	CPU_TO_BE32(s3, v0)         # s3 = x[6]
	xor     t3, t1, s8          #
	addu    a3, a3, v1          #
	lw      s2, 28(a1)          # s2 = in[7]
	addu    a3, a3, t4          #
	and     t3, t3, t0          #
	xor     t3, t3, s8          #
	ror     v1, a3, 27          #
	addu    v1, v1, t3          #
	ror     t0, t0, 2           #
	addu    v1, v1, s3          #
	CPU_TO_BE32(s2, v0)         # s2 = x[7]
	xor     t3, t0, t1          #
	addu    a2, a2, v1          #
	lw      s1, 32(a1)          # s1 = in[8]
	addu    a2, a2, t4          #
	and     t3, t3, a3          #
	xor     t3, t3, t1          #
	ror     v1, a2, 27          #
	addu    v1, v1, t3          #
	ror     a3, a3, 2           #
	addu    v1, v1, s2          #
	CPU_TO_BE32(s1, v0)         # s1 = x[8]
	xor     t3, a3, t0          #
	addu    s8, s8, v1          #
	lw      s0, 36(a1)          # s0 = in[9]
	addu    s8, s8, t4          #
	and     t3, t3, a2          #
	xor     t3, t3, t0          #
	ror     v1, s8, 27          #
	addu    v1, v1, t3          #
	ror     a2, a2, 2           #
	addu    v1, v1, s1          #
	CPU_TO_BE32(s0, v0)         # s0 = x[9]
	xor     t3, a2, a3          #
	addu    t1, t1, v1          #
	lw      t7, 40(a1)          # t7 = in[10]
	addu    t1, t1, t4          #
	and     t3, t3, s8          #
	xor     t3, t3, a3          #
	ror     v1, t1, 27          #
	addu    v1, v1, t3          #
	ror     s8, s8, 2           #
	addu    v1, v1, s0          #
	CPU_TO_BE32(t7, v0)         # t7 = x[10]
	xor     t3, s8, a2          #
	addu    t0, t0, v1          #
	lw      t6, 44(a1)          # t6 = in[11]
	addu    t0, t0, t4          #
	and     t3, t3, t1          #
	xor     t3, t3, a2          #
	ror     v1, t0, 27          #
	addu    v1, v1, t3          #
	ror     t1, t1, 2           #
	addu    v1, v1, t7          #
	CPU_TO_BE32(t6, v0)         # t6 = x[11]
	xor     t3, t1, s8          #
	addu    a3, a3, v1          #
	lw      t2, 48(a1)          # t2 = in[12]
	addu    a3, a3, t4          #
	and     t3, t3, t0          #
	xor     t3, t3, s8          #
	ror     v1, a3, 27          #
	addu    v1, v1, t3          #
	ror     t0, t0, 2           #
	addu    v1, v1, t6          #
	CPU_TO_BE32(t2, v0)         # t2 = x[12]
	xor     t3, t0, t1          #
	addu    a2, a2, v1          #
	lw      t5, 52(a1)          # t5 = in[13]
	addu    a2, a2, t4          #
	and     t3, t3, a3          #
	xor     t3, t3, t1          #
	ror     v1, a2, 27          #
	addu    v1, v1, t3          #
	ror     a3, a3, 2           #
	addu    v1, v1, t2          #
	CPU_TO_BE32(t5, v0)         # t5 = x[13]
	xor     t3, a3, t0          #
	addu    s8, s8, v1          #
	addu    s8, s8, t4          #
	and     t3, t3, a2          #
	lw      a0, 56(a1)          # a0 = in[14]
	xor     t3, t3, t0          #
	ror     v1, s8, 27          #
	addu    v1, v1, t3          #
	ror     a2, a2, 2           #
	addu    v1, v1, t5          #
	CPU_TO_BE32(a0, v0)         # a0 = x[14]
	addu    t1, t1, v1          #
	xor     v1, a2, a3          #
	addu    t1, t1, t4          #
	and     v1, v1, s8          #
	xor     v1, v1, a3          #
	ror     t3, t1, 27          #
	addu    t3, t3, v1          #
	addu    t3, t3, a0          #
	addu    t0, t0, t3          #
	addu    t0, t0, t4          #
	lw      t4, 60(a1)          # t4 = in[15]
	ror     s8, s8, 2           #
	xor     t3, s8, a2          #
	and     t3, t3, t1          #
	CPU_TO_BE32(t4, v0)         # t4 = x[15]
	xor     t3, t3, a2          #
	ror     v0, t0, 27          #
	addu    v0, v0, t3          #
	ror     t1, t1, 2           #
	addu    v0, v0, t4          #
	lui     t3, 0x5a82          #
	ori     t3, t3, 0x7999      #
	xor     v1, t1, s8          #
	addu    a3, a3, v0          #
	xor     t8, t8, s7          #
	addu    a3, a3, t3          #
	xor     t8, t8, s1          #
	and     v1, v1, t0          #
	xor     v1, v1, s8          #
	xor     t8, t8, t5          #
	ror     v0, a3, 27          #
	ror     t8, t8, 31          #
	addu    v0, v0, v1          #
	ror     t0, t0, 2           #
	addu    v0, v0, t8          #
	xor     v1, t0, t1          #
	addu    a2, a2, v0          #
	xor     t9, t9, s6          #
	addu    a2, a2, t3          #
	xor     t9, t9, s0          #
	and     v1, v1, a3          #
	xor     v1, v1, t1          #
	xor     t9, t9, a0          #
	ror     v0, a2, 27          #
	ror     t9, t9, 31          #
	addu    v0, v0, v1          #
	ror     a3, a3, 2           #
	addu    v0, v0, t9          #
	xor     v1, a3, t0          #
	addu    s8, s8, v0          #
	xor     s7, s7, s5          #
	addu    s8, s8, t3          #
	xor     s7, s7, t7          #
	and     v1, v1, a2          #
	xor     v1, v1, t0          #
	xor     s7, s7, t4          #
	ror     v0, s8, 27          #
	ror     s7, s7, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s7          #
	ror     a2, a2, 2           #
	xor     v1, a2, a3          #
	addu    t1, t1, v0          #
	xor     s6, s6, s4          #
	addu    t1, t1, t3          #
	xor     s6, s6, t6          #
	and     v1, v1, s8          #
	xor     v1, v1, a3          #
	xor     s6, s6, t8          #
	ror     v0, t1, 27          #
	ror     s6, s6, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s6          #
	ror     s8, s8, 2           #
	addu    t0, t0, v0          #
	xor     s5, s5, s3          #
	addu    t0, t0, t3          #
	xor     v1, t1, s8          #
	xor     s5, s5, t2          #
	xor     v1, v1, a2          #
	xor     s5, s5, t9          #
	ror     v0, t0, 27          #
	ror     s5, s5, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s5          #
	addu    a3, a3, v0          #
	lui     v0, 0x6ed9          #
	ror     t1, t1, 2           #
	xor     s4, s4, s2          #
	ori     v0, v0, 0xeba1      #
	addu    a3, a3, v0          #
	xor     v1, t0, t1          #
	xor     s4, s4, t5          #
	xor     v1, v1, s8          #
	xor     s4, s4, s7          #
	ror     v0, a3, 27          #
	ror     s4, s4, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s4          #
	lui     v1, 0x6ed9          #
	ror     t0, t0, 2           #
	addu    a2, a2, v0          #
	xor     s3, s3, s1          #
	ori     v1, v1, 0xeba1      #
	addu    a2, a2, v1          #
	xor     s3, s3, a0          #
	xor     v1, a3, t0          #
	xor     v1, v1, t1          #
	xor     s3, s3, s6          #
	ror     v0, a2, 27          #
	ror     s3, s3, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s3          #
	lui     t3, 0x6ed9          #
	ori     t3, t3, 0xeba1      #
	ror     a3, a3, 2           #
	addu    s8, s8, v0          #
	xor     s2, s2, s0          #
	addu    s8, s8, t3          #
	xor     v1, a2, a3          #
	xor     s2, s2, t4          #
	xor     v1, v1, t0          #
	xor     s2, s2, s5          #
	ror     v0, s8, 27          #
	ror     s2, s2, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s2          #
	ror     a2, a2, 2           #
	addu    t1, t1, v0          #
	xor     s1, s1, t7          #
	addu    t1, t1, t3          #
	xor     v1, s8, a2          #
	xor     s1, s1, t8          #
	xor     v1, v1, a3          #
	xor     s1, s1, s4          #
	ror     v0, t1, 27          #
	ror     s1, s1, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s1          #
	ror     s8, s8, 2           #
	addu    t0, t0, v0          #
	xor     s0, s0, t6          #
	addu    t0, t0, t3          #
	xor     v1, t1, s8          #
	xor     s0, s0, t9          #
	xor     v1, v1, a2          #
	xor     s0, s0, s3          #
	ror     v0, t0, 27          #
	ror     s0, s0, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s0          #
	ror     t1, t1, 2           #
	addu    a3, a3, v0          #
	xor     t7, t7, t2          #
	addu    a3, a3, t3          #
	xor     v1, t0, t1          #
	xor     t7, t7, s7          #
	xor     v1, v1, s8          #
	xor     t7, t7, s2          #
	ror     v0, a3, 27          #
	ror     t7, t7, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, t7          #
	ror     t0, t0, 2           #
	addu    a2, a2, v0          #
	xor     t6, t6, t5          #
	addu    a2, a2, t3          #
	xor     v1, a3, t0          #
	xor     t6, t6, s6          #
	xor     v1, v1, t1          #
	xor     t6, t6, s1          #
	ror     v0, a2, 27          #
	ror     t6, t6, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, t6          #
	ror     a3, a3, 2           #
	addu    s8, s8, v0          #
	xor     t2, t2, a0          #
	addu    s8, s8, t3          #
	xor     v1, a2, a3          #
	xor     t2, t2, s5          #
	xor     v1, v1, t0          #
	xor     t2, t2, s0          #
	ror     v0, s8, 27          #
	ror     t2, t2, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, t2          #
	ror     a2, a2, 2           #
	addu    t1, t1, v0          #
	xor     t5, t5, t4          #
	addu    t1, t1, t3          #
	xor     v1, s8, a2          #
	xor     t5, t5, s4          #
	xor     v1, v1, a3          #
	xor     t5, t5, t7          #
	ror     v0, t1, 27          #
	ror     t5, t5, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, t5          #
	ror     s8, s8, 2           #
	addu    t0, t0, v0          #
	xor     a0, a0, t8          #
	addu    t0, t0, t3          #
	xor     v1, t1, s8          #
	xor     a0, a0, s3          #
	xor     v1, v1, a2          #
	xor     a0, a0, t6          #
	ror     v0, t0, 27          #
	ror     a0, a0, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, a0          #
	ror     t1, t1, 2           #
	addu    a3, a3, v0          #
	xor     t4, t4, t9          #
	addu    a3, a3, t3          #
	xor     v1, t0, t1          #
	xor     t4, t4, s2          #
	xor     v1, v1, s8          #
	xor     t4, t4, t2          #
	ror     v0, a3, 27          #
	ror     t4, t4, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, t4          #
	ror     t0, t0, 2           #
	addu    a2, a2, v0          #
	xor     t8, t8, s7          #
	addu    a2, a2, t3          #
	xor     v1, a3, t0          #
	xor     t8, t8, s1          #
	xor     v1, v1, t1          #
	xor     t8, t8, t5          #
	ror     v0, a2, 27          #
	ror     t8, t8, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, t8          #
	ror     a3, a3, 2           #
	addu    s8, s8, v0          #
	xor     t9, t9, s6          #
	addu    s8, s8, t3          #
	xor     v1, a2, a3          #
	xor     t9, t9, s0          #
	xor     v1, v1, t0          #
	xor     t9, t9, a0          #
	ror     v0, s8, 27          #
	ror     t9, t9, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, t9          #
	ror     a2, a2, 2           #
	addu    t1, t1, v0          #
	xor     s7, s7, s5          #
	addu    t1, t1, t3          #
	xor     v1, s8, a2          #
	xor     s7, s7, t7          #
	xor     v1, v1, a3          #
	xor     s7, s7, t4          #
	ror     v0, t1, 27          #
	ror     s7, s7, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s7          #
	ror     s8, s8, 2           #
	addu    t0, t0, v0          #
	xor     s6, s6, s4          #
	addu    t0, t0, t3          #
	xor     v1, t1, s8          #
	xor     s6, s6, t6          #
	xor     v1, v1, a2          #
	xor     s6, s6, t8          #
	ror     v0, t0, 27          #
	ror     s6, s6, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s6          #
	ror     t1, t1, 2           #
	addu    a3, a3, v0          #
	xor     s5, s5, s3          #
	addu    a3, a3, t3          #
	xor     v1, t0, t1          #
	xor     s5, s5, t2          #
	xor     v1, v1, s8          #
	xor     s5, s5, t9          #
	ror     v0, a3, 27          #
	ror     s5, s5, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s5          #
	ror     t0, t0, 2           #
	addu    a2, a2, v0          #
	xor     s4, s4, s2          #
	addu    a2, a2, t3          #
	xor     v1, a3, t0          #
	xor     s4, s4, t5          #
	xor     v1, v1, t1          #
	xor     s4, s4, s7          #
	ror     v0, a2, 27          #
	ror     s4, s4, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s4          #
	ror     a3, a3, 2           #
	addu    s8, s8, v0          #
	xor     s3, s3, s1          #
	addu    s8, s8, t3          #
	xor     v1, a2, a3          #
	xor     s3, s3, a0          #
	xor     v1, v1, t0          #
	xor     s3, s3, s6          #
	ror     v0, s8, 27          #
	ror     s3, s3, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s3          #
	ror     a2, a2, 2           #
	addu    t1, t1, v0          #
	xor     s2, s2, s0          #
	addu    t1, t1, t3          #
	xor     v1, s8, a2          #
	xor     s2, s2, t4          #
	xor     v1, v1, a3          #
	xor     s2, s2, s5          #
	ror     v0, t1, 27          #
	ror     s2, s2, 31          #
	addu    v0, v0, v1          #
	ror     s8, s8, 2           #
	addu    v0, v0, s2          #
	or      v1, t1, s8          #
	addu    t0, t0, v0          #
	xor     s1, s1, t7          #
	addu    t0, t0, t3          #
	and     v0, t1, s8          #
	xor     s1, s1, t8          #
	and     v1, v1, a2          #
	or      v1, v1, v0          #
	xor     s1, s1, s4          #
	ror     v0, t0, 27          #
	ror     s1, s1, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s1          #
	ror     t1, t1, 2           #
	addu    a3, a3, v0          #
	lui     v0, 0x8f1b          #
	or      v1, t0, t1          #
	xor     s0, s0, t6          #
	ori     v0, v0, 0xbcdc      #
	addu    a3, a3, v0          #
	xor     s0, s0, t9          #
	and     v0, t0, t1          #
	and     v1, v1, s8          #
	or      v1, v1, v0          #
	xor     s0, s0, s3          #
	ror     v0, a3, 27          #
	ror     s0, s0, 31          #
	addu    v0, v0, v1          #
	ror     t0, t0, 2           #
	addu    v0, v0, s0          #
	lui     t3, 0x8f1b          #
	ori     t3, t3, 0xbcdc      #
	or      v1, a3, t0          #
	addu    a2, a2, v0          #
	xor     t7, t7, t2          #
	addu    a2, a2, t3          #
	and     v0, a3, t0          #
	xor     t7, t7, s7          #
	and     v1, v1, t1          #
	or      v1, v1, v0          #
	xor     t7, t7, s2          #
	ror     v0, a2, 27          #
	ror     t7, t7, 31          #
	addu    v0, v0, v1          #
	ror     a3, a3, 2           #
	addu    v0, v0, t7          #
	or      v1, a2, a3          #
	addu    s8, s8, v0          #
	xor     t6, t6, t5          #
	addu    s8, s8, t3          #
	and     v0, a2, a3          #
	xor     t6, t6, s6          #
	and     v1, v1, t0          #
	or      v1, v1, v0          #
	xor     t6, t6, s1          #
	ror     v0, s8, 27          #
	ror     t6, t6, 31          #
	addu    v0, v0, v1          #
	ror     a2, a2, 2           #
	addu    v0, v0, t6          #
	or      v1, s8, a2          #
	addu    t1, t1, v0          #
	xor     t2, t2, a0          #
	addu    t1, t1, t3          #
	and     v0, s8, a2          #
	xor     t2, t2, s5          #
	and     v1, v1, a3          #
	or      v1, v1, v0          #
	xor     t2, t2, s0          #
	ror     v0, t1, 27          #
	ror     t2, t2, 31          #
	addu    v0, v0, v1          #
	ror     s8, s8, 2           #
	addu    v0, v0, t2          #
	or      v1, t1, s8          #
	addu    t0, t0, v0          #
	xor     t5, t5, t4          #
	addu    t0, t0, t3          #
	and     v0, t1, s8          #
	xor     t5, t5, s4          #
	and     v1, v1, a2          #
	or      v1, v1, v0          #
	xor     t5, t5, t7          #
	ror     v0, t0, 27          #
	ror     t5, t5, 31          #
	addu    v0, v0, v1          #
	ror     t1, t1, 2           #
	addu    v0, v0, t5          #
	or      v1, t0, t1          #
	addu    a3, a3, v0          #
	xor     a0, a0, t8          #
	addu    a3, a3, t3          #
	and     v0, t0, t1          #
	xor     a0, a0, s3          #
	and     v1, v1, s8          #
	or      v1, v1, v0          #
	xor     a0, a0, t6          #
	ror     v0, a3, 27          #
	ror     a0, a0, 31          #
	addu    v0, v0, v1          #
	ror     t0, t0, 2           #
	addu    v0, v0, a0          #
	or      v1, a3, t0          #
	addu    a2, a2, v0          #
	xor     t4, t4, t9          #
	addu    a2, a2, t3          #
	and     v0, a3, t0          #
	xor     t4, t4, s2          #
	and     v1, v1, t1          #
	or      v1, v1, v0          #
	xor     t4, t4, t2          #
	ror     v0, a2, 27          #
	ror     t4, t4, 31          #
	addu    v0, v0, v1          #
	ror     a3, a3, 2           #
	addu    v0, v0, t4          #
	or      v1, a2, a3          #
	addu    s8, s8, v0          #
	xor     t8, t8, s7          #
	addu    s8, s8, t3          #
	and     v0, a2, a3          #
	xor     t8, t8, s1          #
	and     v1, v1, t0          #
	or      v1, v1, v0          #
	xor     t8, t8, t5          #
	ror     v0, s8, 27          #
	ror     t8, t8, 31          #
	addu    v0, v0, v1          #
	ror     a2, a2, 2           #
	addu    v0, v0, t8          #
	or      v1, s8, a2          #
	addu    t1, t1, v0          #
	xor     t9, t9, s6          #
	addu    t1, t1, t3          #
	and     v0, s8, a2          #
	xor     t9, t9, s0          #
	and     v1, v1, a3          #
	or      v1, v1, v0          #
	xor     t9, t9, a0          #
	ror     v0, t1, 27          #
	ror     t9, t9, 31          #
	addu    v0, v0, v1          #
	ror     s8, s8, 2           #
	addu    v0, v0, t9          #
	or      v1, t1, s8          #
	addu    t0, t0, v0          #
	xor     s7, s7, s5          #
	addu    t0, t0, t3          #
	and     v0, t1, s8          #
	xor     s7, s7, t7          #
	and     v1, v1, a2          #
	or      v1, v1, v0          #
	xor     s7, s7, t4          #
	ror     v0, t0, 27          #
	ror     s7, s7, 31          #
	addu    v0, v0, v1          #
	ror     t1, t1, 2           #
	addu    v0, v0, s7          #
	or      v1, t0, t1          #
	addu    a3, a3, v0          #
	xor     s6, s6, s4          #
	addu    a3, a3, t3          #
	and     v0, t0, t1          #
	xor     s6, s6, t6          #
	and     v1, v1, s8          #
	or      v1, v1, v0          #
	xor     s6, s6, t8          #
	ror     v0, a3, 27          #
	ror     s6, s6, 31          #
	addu    v0, v0, v1          #
	ror     t0, t0, 2           #
	addu    v0, v0, s6          #
	or      v1, a3, t0          #
	addu    a2, a2, v0          #
	xor     s5, s5, s3          #
	addu    a2, a2, t3          #
	and     v0, a3, t0          #
	xor     s5, s5, t2          #
	and     v1, v1, t1          #
	or      v1, v1, v0          #
	xor     s5, s5, t9          #
	ror     v0, a2, 27          #
	ror     s5, s5, 31          #
	addu    v0, v0, v1          #
	ror     a3, a3, 2           #
	addu    v0, v0, s5          #
	or      v1, a2, a3          #
	addu    s8, s8, v0          #
	xor     s4, s4, s2          #
	addu    s8, s8, t3          #
	and     v0, a2, a3          #
	xor     s4, s4, t5          #
	and     v1, v1, t0          #
	or      v1, v1, v0          #
	xor     s4, s4, s7          #
	ror     v0, s8, 27          #
	ror     s4, s4, 31          #
	addu    v0, v0, v1          #
	ror     a2, a2, 2           #
	addu    v0, v0, s4          #
	or      v1, s8, a2          #
	addu    t1, t1, v0          #
	xor     s3, s3, s1          #
	addu    t1, t1, t3          #
	and     v0, s8, a2          #
	xor     s3, s3, a0          #
	and     v1, v1, a3          #
	or      v1, v1, v0          #
	xor     s3, s3, s6          #
	ror     v0, t1, 27          #
	ror     s3, s3, 31          #
	addu    v0, v0, v1          #
	ror     s8, s8, 2           #
	addu    v0, v0, s3          #
	or      v1, t1, s8          #
	addu    t0, t0, v0          #
	xor     s2, s2, s0          #
	addu    t0, t0, t3          #
	and     v0, t1, s8          #
	xor     s2, s2, t4          #
	and     v1, v1, a2          #
	or      v1, v1, v0          #
	xor     s2, s2, s5          #
	ror     v0, t0, 27          #
	ror     s2, s2, 31          #
	addu    v0, v0, v1          #
	ror     t1, t1, 2           #
	addu    v0, v0, s2          #
	or      v1, t0, t1          #
	addu    a3, a3, v0          #
	xor     s1, s1, t7          #
	addu    a3, a3, t3          #
	and     v0, t0, t1          #
	xor     s1, s1, t8          #
	and     v1, v1, s8          #
	or      v1, v1, v0          #
	xor     s1, s1, s4          #
	ror     v0, a3, 27          #
	ror     s1, s1, 31          #
	addu    v0, v0, v1          #
	ror     t0, t0, 2           #
	addu    v0, v0, s1          #
	or      v1, a3, t0          #
	addu    a2, a2, v0          #
	xor     s0, s0, t6          #
	addu    a2, a2, t3          #
	and     v0, a3, t0          #
	xor     s0, s0, t9          #
	and     v1, v1, t1          #
	or      v1, v1, v0          #
	xor     s0, s0, s3          #
	ror     v0, a2, 27          #
	ror     s0, s0, 31          #
	addu    v0, v0, v1          #
	ror     a3, a3, 2           #
	addu    v0, v0, s0          #
	or      v1, a2, a3          #
	addu    s8, s8, v0          #
	xor     t7, t7, t2          #
	addu    s8, s8, t3          #
	and     v0, a2, a3          #
	xor     t7, t7, s7          #
	and     v1, v1, t0          #
	or      v1, v1, v0          #
	xor     t7, t7, s2          #
	ror     v0, s8, 27          #
	ror     t7, t7, 31          #
	addu    v0, v0, v1          #
	ror     a2, a2, 2           #
	addu    v0, v0, t7          #
	or      v1, s8, a2          #
	addu    t1, t1, v0          #
	xor     t6, t6, t5          #
	addu    t1, t1, t3          #
	and     v0, s8, a2          #
	xor     t6, t6, s6          #
	and     v1, v1, a3          #
	or      v1, v1, v0          #
	xor     t6, t6, s1          #
	ror     v0, t1, 27          #
	ror     t6, t6, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, t6          #
	ror     s8, s8, 2           #
	addu    t0, t0, v0          #
	xor     t2, t2, a0          #
	addu    t0, t0, t3          #
	xor     v1, t1, s8          #
	xor     t2, t2, s5          #
	xor     v1, v1, a2          #
	xor     t2, t2, s0          #
	ror     v0, t0, 27          #
	ror     t2, t2, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, t2          #
	addu    a3, a3, v0          #
	lui     v0, 0xca62          #
	ror     t1, t1, 2           #
	xor     t5, t5, t4          #
	ori     v0, v0, 0xc1d6      #
	addu    a3, a3, v0          #
	xor     v1, t0, t1          #
	xor     t5, t5, s4          #
	xor     v1, v1, s8          #
	xor     t5, t5, t7          #
	ror     v0, a3, 27          #
	ror     t5, t5, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, t5          #
	lui     v1, 0xca62          #
	ror     t0, t0, 2           #
	addu    a2, a2, v0          #
	xor     a0, a0, t8          #
	ori     v1, v1, 0xc1d6      #
	addu    a2, a2, v1          #
	xor     a0, a0, s3          #
	xor     v1, a3, t0          #
	xor     v1, v1, t1          #
	xor     a0, a0, t6          #
	ror     v0, a2, 27          #
	ror     a0, a0, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, a0          #
	lui     t3, 0xca62          #
	ori     t3, t3, 0xc1d6      #
	ror     a3, a3, 2           #
	addu    s8, s8, v0          #
	xor     t4, t4, t9          #
	addu    s8, s8, t3          #
	xor     v1, a2, a3          #
	xor     t4, t4, s2          #
	xor     v1, v1, t0          #
	xor     t4, t4, t2          #
	ror     v0, s8, 27          #
	ror     t4, t4, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, t4          #
	ror     a2, a2, 2           #
	addu    t1, t1, v0          #
	xor     t8, t8, s7          #
	addu    t1, t1, t3          #
	xor     v1, s8, a2          #
	xor     t8, t8, s1          #
	xor     v1, v1, a3          #
	xor     t8, t8, t5          #
	ror     v0, t1, 27          #
	ror     t8, t8, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, t8          #
	ror     s8, s8, 2           #
	addu    t0, t0, v0          #
	xor     t9, t9, s6          #
	addu    t0, t0, t3          #
	xor     v1, t1, s8          #
	xor     t9, t9, s0          #
	xor     v1, v1, a2          #
	xor     t9, t9, a0          #
	ror     v0, t0, 27          #
	ror     t9, t9, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, t9          #
	ror     t1, t1, 2           #
	addu    a3, a3, v0          #
	xor     s7, s7, s5          #
	addu    a3, a3, t3          #
	xor     v1, t0, t1          #
	xor     s7, s7, t7          #
	xor     v1, v1, s8          #
	xor     s7, s7, t4          #
	ror     v0, a3, 27          #
	ror     s7, s7, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s7          #
	ror     t0, t0, 2           #
	addu    a2, a2, v0          #
	xor     s6, s6, s4          #
	addu    a2, a2, t3          #
	xor     v1, a3, t0          #
	xor     s6, s6, t6          #
	xor     v1, v1, t1          #
	ror     v0, a2, 27          #
	xor     s6, s6, t8          #
	ror     s6, s6, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s6          #
	ror     a3, a3, 2           #
	addu    s8, s8, v0          #
	xor     s5, s5, s3          #
	addu    s8, s8, t3          #
	xor     v1, a2, a3          #
	xor     s5, s5, t2          #
	xor     v1, v1, t0          #
	ror     v0, s8, 27          #
	xor     s5, s5, t9          #
	ror     s5, s5, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s5          #
	ror     a2, a2, 2           #
	addu    t1, t1, v0          #
	xor     s4, s4, s2          #
	addu    t1, t1, t3          #
	xor     v1, s8, a2          #
	xor     s4, s4, t5          #
	xor     v1, v1, a3          #
	ror     v0, t1, 27          #
	xor     s4, s4, s7          #
	ror     s4, s4, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s4          #
	ror     s8, s8, 2           #
	addu    t0, t0, v0          #
	xor     s3, s3, s1          #
	addu    t0, t0, t3          #
	xor     v1, t1, s8          #
	xor     s3, s3, a0          #
	xor     v1, v1, a2          #
	ror     v0, t0, 27          #
	xor     s3, s3, s6          #
	ror     s3, s3, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s3          #
	ror     t1, t1, 2           #
	addu    a3, a3, v0          #
	xor     s2, s2, s0          #
	addu    a3, a3, t3          #
	xor     v1, t0, t1          #
	xor     s2, s2, t4          #
	xor     v1, v1, s8          #
	ror     v0, a3, 27          #
	xor     s2, s2, s5          #
	ror     s2, s2, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, s2          #
	ror     t0, t0, 2           #
	addu    a2, a2, v0          #
	xor     s1, s1, t7          #
	addu    a2, a2, t3          #
	xor     v1, a3, t0          #
	xor     s1, s1, t8          #
	xor     v1, v1, t1          #
	ror     v0, a2, 27          #
	xor     s1, s1, s4          #
	addu    v0, v0, v1          #
	ror     s1, s1, 31          #
	addu    v0, v0, s1          #
	ror     a3, a3, 2           #
	addu    s8, s8, v0          #
	xor     s0, s0, t6          #
	addu    s8, s8, t3          #
	xor     v1, a2, a3          #
	xor     s0, s0, t9          #
	xor     v1, v1, t0          #
	ror     v0, s8, 27          #
	xor     s0, s0, s3          #
	addu    v0, v0, v1          #
	ror     s0, s0, 31          #
	addu    v0, v0, s0          #
	ror     a2, a2, 2           #
	addu    t1, t1, v0          #
	xor     t7, t7, t2          #
	addu    t1, t1, t3          #
	xor     v1, s8, a2          #
	xor     t7, t7, s7          #
	xor     v1, v1, a3          #
	ror     v0, t1, 27          #
	xor     t7, t7, s2          #
	addu    v0, v0, v1          #
	ror     t7, t7, 31          #
	addu    v0, v0, t7          #
	ror     s8, s8, 2           #
	addu    t0, t0, v0          #
	xor     t6, t6, t5          #
	addu    t0, t0, t3          #
	xor     v1, t1, s8          #
	xor     t6, t6, s6          #
	xor     v1, v1, a2          #
	ror     v0, t0, 27          #
	xor     t6, t6, s1          #
	addu    v0, v0, v1          #
	ror     t6, t6, 31          #
	addu    v0, v0, t6          #
	ror     t1, t1, 2           #
	addu    a3, a3, v0          #
	xor     t2, t2, a0          #
	addu    a3, a3, t3          #
	xor     v1, t0, t1          #
	xor     t2, t2, s5          #
	xor     v1, v1, s8          #
	ror     v0, a3, 27          #
	xor     t2, t2, s0          #
	ror     t2, t2, 31          #
	addu    v0, v0, v1          #
	addu    v0, v0, t2          #
	ror     t0, t0, 2           #
	addu    a2, a2, v0          #
	xor     t5, t5, t4          #
	addu    a2, a2, t3          #
	xor     v1, a3, t0          #
	xor     t5, t5, s4          #
	xor     v1, v1, t1          #
	ror     v0, a2, 27          #
	xor     t5, t5, t7          #
	addu    v0, v0, v1          #
	ror     t5, t5, 31          #
	addu    v0, v0, t5          #
	ror     a3, a3, 2           #
	addu    s8, s8, v0          #
	xor     a0, a0, t8          #
	addu    s8, s8, t3          #
	xor     v1, a2, a3          #
	xor     a0, a0, s3          #
	xor     v1, v1, t0          #
	ror     v0, s8, 27          #
	xor     a0, a0, t6          #
	addu    v0, v0, v1          #
	ror     a0, a0, 31          #
	addu    v0, v0, a0          #
	xor     t4, t4, t9          #
	addu    t1, t1, v0          #
	ror     a2, a2, 2           #
	xor     t4, t4, s2          #
	addu    t1, t1, t3          #
	xor     v0, s8, a2          #
	xor     t4, t4, t2          #
	xor     v0, v0, a3          #
	ror     v1, t1, 27          #
	addu    v1, v1, v0          #
	ror     t4, t4, 31          #
	addu    v1, v1, t4          #
	addu    t0, t0, v1          #
	lw      v0, SPO_STATE0      # v0 = state0
	lw      t3, SPO_STATE1      # t3 = state1
	lw      t4, SPO_STATE2      # t4 = state2
	lw      a0, SPO_STATE3      # a0 = state3
#if ! defined (STATE4_IN_AT)
	lw      t5, SPO_STATE4      # t5 = state4
#endif
	lui     v1, 0xca62          #
	ori     v1, v1, 0xc1d6      #
	ror     s8, s8, 2           #
	addu    t0, t0, v1          #
	addu    t2, s8, t4          # t2 = state2 + C
#if defined (STATE4_IN_AT)
	addu    t4, a3, AT          # t4 = state4 + E
#else
	addu    t4, a3, t5          # t4 = state4 + E
#endif
	addu    t0, t0, v0          # t0 = state0 + A
	addu    t1, t1, t3          # t1 = state1 + B
	addu    t3, a2, a0          # t3 = state3 + D
	addiu   ra, ra, -1          # iterations--
	bnez    ra, 1b              # loop if (iterations != 0)
	addiu   a1, a1, 64          # (bdslot) in += 16

	#-------------------------------------------------------------

	lw      t5, SPO_STATE       # t5 = &state[0]
	lw      s0, SPO_S0	    #
	lw      s1, SPO_S1	    #
	lw      s2, SPO_S2	    #
	lw      s3, SPO_S3	    #
	lw      s4, SPO_S4	    #
	lw      s5, SPO_S5	    #
	lw      s6, SPO_S6	    #
	lw      s7, SPO_S7	    #
	lw      s8, SPO_S8	    #
	lw      ra, SPO_RA	    #
	sw      t0, 0(t5)           # return final result : state[0]
	sw      t1, 4(t5)           # return final result : state[1]
	sw      t2, 8(t5)           # return final result : state[2]
	sw      t3, 12(t5)          # return final result : state[3]
	sw      t4, 16(t5)          # return final result : state[4]

2:	jr      ra                  #
	addiu   sp, sp, SF_SIZE     # (bdslot) return stack frame

	#-------------------------------------------------------------

	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x41,0x6e,0x64,0x72,0x65,0x20,0x4d,0x63,0x43,0x75,0x72,0x64
	.byte	0x79,0x20,0x20,0x20,0x32,0x30,0x30,0x37,0x2d,0x30,0x37,0x2d
	.byte	0x31,0x38,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00

	#-------------------------------------------------------------

	.set	at
	.set    macro
	.set    reorder

	.end    SHA1_Transform_asm

